using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline.Processors;
using System.IO;

namespace DataStorageContentExtension
{
    [ContentImporter( ".xml", DisplayName = "Data storage importer", DefaultProcessor = "No Processing Required" )]
    public class DataStorageContentImporter : ContentImporter<byte[]>
    {
        public override byte[] Import( string filename, ContentImporterContext context )
        {
            Stream stream = new FileStream( filename, FileMode.Open, FileAccess.Read );
            byte[] buffer = new byte[stream.Length];

            if ( stream.Length > int.MaxValue )
                throw new NotImplementedException( "Loading files this large into memory is not supported." );
            else
                stream.Read( buffer, 0, (int)stream.Length );

            stream.Close();

            return buffer;
        }
    }
}
