﻿
namespace Jypeli.Assets
{
    /// <summary>
    /// Aivot, jotka laittavat omistajansa hortoilemaan tasohyppelytasoa
    /// edestakaisin.
    /// </summary>
    internal class PlatformWandererBrain : Brain
    {
        private PhysicsObject platform;
        private double _speed = 20;
    
        public Direction Direction { get; set; }

        /// <summary>
        /// Nopeus.
        /// </summary>
        public double Speed
        {
            get { return _speed; }
            set { _speed = value; }
        }

        public PlatformWandererBrain()
        {
            Direction = Direction.Right;
        }

        public override void OnCollision( GameObject target )
        {
            if ( target is PhysicsObject && Owner.Y > target.Y && target.Width > Owner.Width )
            {
                platform = (PhysicsObject)target;

                // ...
            }

            base.OnCollision( target );
        }
    }
}
