using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

#if WINDOWS_PHONE
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework;
#endif

namespace Jypeli.WP7
{
    public class TouchPanelState
    {
        /// <summary>
        /// Aktiiviset kosketukset ruudulla
        /// </summary>
        public List<Touch> ActiveTouches;

        public TouchPanelState()
        {
            ActiveTouches = new List<Touch>( 5 );
        }

#if WINDOWS_PHONE
        public TouchPanelState( TouchCollection touchCollection, TouchPanelState prevState )
        {
            ActiveTouches = new List<Touch>();

            for ( int i = 0; i < touchCollection.Count; i++ )
            {
                GetTouchObject( touchCollection[i], prevState );
            }
        }

        private Touch GetTouchObject( TouchLocation location, TouchPanelState prevState )
        {
            Touch touch = null;

            for ( int i = 0; i < prevState.ActiveTouches.Count; i++ )
            {
                if ( location.Id == prevState.ActiveTouches[i].Id )
                {
                    touch = prevState.ActiveTouches[i];
                    touch.Update( location.Position, location.State );

                    ActiveTouches.Add( touch );
                    return touch;
                }
            }

            touch = new Touch( location.Id, location.Position, location.State );
            ActiveTouches.Add( touch );

            return touch;
        }
#endif
    }
}
