﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;

namespace LevelEditor
{
    public struct Coordinates
    {
        public int X;
        public int Y;

        public Coordinates( int x, int y )
        {
            this.X = x;
            this.Y = y;
        }

        public static Coordinates FromVector( Vector v, Grid grid )
        {
            Coordinates result;
            result.X = (int)Math.Floor( v.X / grid.CellSize.X );
            result.Y = (int)Math.Floor( v.Y / grid.CellSize.Y );
            return result;
        }

        public Vector ToVector( Grid grid )
        {
            return new Vector( this.X * grid.CellSize.X + grid.CellSize.X / 2, this.Y * grid.CellSize.Y + grid.CellSize.Y / 2 );
        }
    }
}
