using System;

static class Program
{
    static string LevelFile = null;

    static void Usage()
    {
        Console.OpenStandardError();
        Console.Error.WriteLine( "Usage: {0} [levelfile.level]", Environment.GetCommandLineArgs()[0] );
    }

    static bool ParseArguments( string[] args )
    {
        if ( args.Length > 1 )
        {
            Usage();
            return false;
        }

        if ( args.Length == 1 )
        {
            LevelFile = args[0];
        }

        return true;
    }

    static void Main(string[] args)
    {
        if ( !ParseArguments( args ) ) return;

        using ( LevelEditor.LevelEditor editor = new LevelEditor.LevelEditor( LevelFile ) )
        {
            editor.IsFullScreen = false;
            editor.Run();
        }
    }
}
