﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli.Widgets;
using Jypeli;
using Jypeli.Controls;

namespace LevelEditor.Tools
{
    abstract class Handle : Widget
    {
        protected static Camera Camera { get { return Game.Instance.Camera; } }
        protected static ScreenView Screen { get { return Game.Screen; } }
        protected static Mouse Mouse { get { return Game.Instance.Mouse; } }
        protected static Keyboard Keyboard { get { return Game.Instance.Keyboard; } }

        protected ObjectPair SelectedObject;

        protected Vector UnitX
        {
            get { return Vector.FromLengthAndAngle( 1, SelectedObject.GameObject.Angle ); }
        }

        protected Vector UnitY
        {
            get { return Vector.FromLengthAndAngle( 1, SelectedObject.GameObject.Angle + Angle.RightAngle ); }
        }

        protected Handle( ObjectPair obj, double width, double height, Shape shape, Color color )
            : base( width, height, shape )
        {
            if ( obj == null )
                throw new ArgumentNullException( "Cannot have a handle for null object!" );

            this.Color = color;
            this.SelectedObject = obj;
        }

        public abstract void OnDrag();
        public abstract void OnEndDrag();
        public abstract void Update();
    }
}
