﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;
using Jypeli.LevelEditor;

namespace LevelEditor.Tools
{
    class HorizontalSizeHandle : Handle
    {
        public HorizontalSizeHandle( ObjectPair obj )
            : base( obj, 20, 20, Shape.Rectangle, Color.Green )
        {
        }

        public override void OnDrag()
        {
            double tx = Mouse.PositionOnScreen.ScalarProjection( UnitX );
            double ty = this.Position.ScalarProjection( UnitY );
            this.Position = tx * UnitX + ty * UnitY;

            Vector dragPosition = Camera.ScreenToWorld( this.Position );

            if ( Keyboard.IsCtrlDown() )
            {
                dragPosition = LevelEditor.Grid.SnapToLines( dragPosition );
                this.Position = Camera.WorldToScreen( dragPosition );
            }

            double oldTx = SelectedObject.GameObject.Position.ScalarProjection( UnitX );
            double newTx = dragPosition.ScalarProjection( UnitX );
            SelectedObject.GameObject.Width = Math.Abs( newTx - oldTx ) * 2;
        }

        public override void OnEndDrag()
        {
            SelectedObject.LevelObject.OverridingProperties.SetValue( "Size", SelectedObject.GameObject.Size );
        }

        public override void Update()
        {
            this.Position = Camera.WorldToScreen( SelectedObject.GameObject.Position + Vector.FromLengthAndAngle( SelectedObject.GameObject.Width / 2, SelectedObject.GameObject.Angle ) );
        }
    }
}
