﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;
using Jypeli.Controls;
using Jypeli.LevelEditor;

namespace LevelEditor.Tools
{
    public sealed class Insert : Tool
    {
        protected override void AddControls()
        {
            Mouse.Listen( MouseButton.Left, ButtonState.Pressed, MousePressed, "Insert object" ).InContext( this );
        }

        private void MousePressed()
        {
            Template selectedTemplate = LevelEditor.TemplateMenu.SelectedTemplate;

            if ( selectedTemplate != null )
            {
                Vector position = Mouse.PositionOnWorld;
                if ( Keyboard.IsCtrlDown() )
                {
                    Grid grid = LevelEditor.Grid;
                    position = Coordinates.FromVector( position, grid ).ToVector( grid );
                }
                LevelEditor.InsertObject( position, selectedTemplate );
            }
        }
    }
}
