@echo off
setlocal
rem | Compiles the library

set outputDir=Compiled
set DefaultFrameworkDir=%WINDIR%\Microsoft.NET\Framework

set copy_game=xcopy /D /S /Q /I /Y /EXCLUDE:etc\files_excluded_from_release_builds.txt
set copy_if_newer=xcopy /D /S /Q /I /Y

if not defined FrameworkDir (
   set FrameworkDir=%DefaultFrameworkDir%
)

echo %FrameworkDir%
if not exist %FrameworkDir%\v4.0.30319 (
  ECHO.
  ECHO.
  echo .NET Framework 4.0 required.
  ECHO.
  ECHO.
  goto error
)


set msbuild=%FrameworkDir%\v4.0.30319\MSBuild.exe

%msbuild% Jypeli.proj
if errorlevel 1 goto error

if not exist %outputDir% mkdir %outputDir%
if not exist %outputDir%\x86 mkdir %outputDir%\x86
if not exist "%outputDir%\Windows Phone" mkdir "%outputDir%\Windows Phone"
if not exist "%outputDir%\ContentExtensions" mkdir "%outputDir%\ContentExtensions"

if not exist %outputDir%\x86\Jypeli mkdir %outputDir%\x86\Jypeli
if not exist "%outputDir%\Windows Phone\Jypeli" mkdir "%outputDir%\Windows Phone\Jypeli"

%copy_if_newer% Jypeli\bin\x86\Release\Jypeli4.dll %outputDir%\x86\Jypeli
%copy_if_newer% Jypeli\bin\x86\Release\Jypeli4.xml %outputDir%\x86\Jypeli

%copy_if_newer% "Jypeli\bin\Windows Phone\Release\Jypeli4.dll" "%outputDir%\Windows Phone\Jypeli"
%copy_if_newer% "Jypeli\bin\Windows Phone\Release\Jypeli4.xml" "%outputDir%\Windows Phone\Jypeli"
%copy_if_newer% "WP7\JypeliCamera\bin\Windows Phone\Release\Jypeli.WP7.Camera.dll" "%outputDir%\Windows Phone\Jypeli"
%copy_if_newer% "WP7\JypeliCamera\bin\Windows Phone\Release\Jypeli.WP7.Camera.xml" "%outputDir%\Windows Phone\Jypeli"
%copy_if_newer% "WP7\JypeliGPS\bin\Windows Phone\Release\Jypeli.WP7.GPS.dll" "%outputDir%\Windows Phone\Jypeli"
%copy_if_newer% "WP7\JypeliGPS\bin\Windows Phone\Release\Jypeli.WP7.GPS.xml" "%outputDir%\Windows Phone\Jypeli"

%copy_if_newer% "TextFileContentExtension\bin\x86\Release\TextFileContentExtension.dll" "%outputDir%\ContentExtensions"

%copy_game% esimerkit\Autopeli\bin\x86\Release %outputDir%\x86\Autopeli
%copy_game% esimerkit\FallDown\FallDown\bin\x86\Release %outputDir%\x86\FallDown
%copy_game% esimerkit\Koripallopeli\bin\x86\Release %outputDir%\x86\Koripallopeli
%copy_game% esimerkit\LumiUkko\bin\x86\Release %outputDir%\x86\LumiUkko
%copy_game% esimerkit\LumiUkko2\bin\x86\Release %outputDir%\x86\LumiUkko2
%copy_game% esimerkit\Marswagen\bin\x86\Release %outputDir%\x86\Marswagen
%copy_game% esimerkit\Muistipeli\bin\x86\Release %outputDir%\x86\Muistipeli
%copy_if_newer% esimerkit\Muistipeli\bin\x86\Debug\elaimet %outputDir%\x86\Muistipeli\elaimet
%copy_if_newer% esimerkit\Muistipeli\bin\x86\Debug\ihmiset %outputDir%\x86\Muistipeli\ihmiset
%copy_game% esimerkit\Piano\bin\x86\Release %outputDir%\x86\Piano
%copy_game% "esimerkit\Piano\bin\Windows Phone\Release" "%outputDir%\Windows Phone\Piano"
%copy_game% esimerkit\Pong\Vaihe1\bin\x86\Release %outputDir%\x86\Pong\Vaihe1
%copy_game% esimerkit\Pong\Vaihe2\bin\x86\Release %outputDir%\x86\Pong\Vaihe2
%copy_game% esimerkit\Pong\Vaihe3\bin\x86\Release %outputDir%\x86\Pong\Vaihe3
%copy_game% esimerkit\Pong\Vaihe4\bin\x86\Release %outputDir%\x86\Pong\Vaihe4
%copy_game% esimerkit\Pong\Vaihe5\bin\x86\Release %outputDir%\x86\Pong\Vaihe5
%copy_game% esimerkit\Pong\Vaihe6\bin\x86\Release %outputDir%\x86\Pong\Vaihe6
%copy_game% esimerkit\Pong\Vaihe7\bin\x86\Release %outputDir%\x86\Pong\Vaihe7
%copy_game% esimerkit\SpaceElephant\SpaceElephant\SpaceElephant\bin\x86\Release %outputDir%\x86\SpaceElephant
%copy_game% esimerkit\ViimeinenSysteemi\bin\x86\Release %outputDir%\x86\ViimeinenSysteemi

goto end


:error
endlocal
exit /B 1


:end
endlocal
