﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;
using Jypeli.Controls;
using Jypeli.WP7;

public class Peli : PhysicsGame
{

    List<PhysicsObject> pallot;    

    public override void Begin()
    {        
        Phone.DisplayOrientation = DisplayOrientation.LandscapeLeft;
        Level.Width = 800;
        Level.Height = 480;
        Level.CreateBorders();
        Camera.ZoomToLevel();

        Gravity = Vector.Zero;
        pallot = new List<PhysicsObject>();

        Accelerometer.Calibration = AccelerometerCalibration.ZeroAngle;
        Accelerometer.ListenAnalog(MuutaPainoVoimanSuunta, null);
        Accelerometer.Listen(AccelerometerDirection.Shake, LyoPalloja, null, 3000.0, 150);
        Accelerometer.Listen(AccelerometerDirection.Tap, LyoPalloja, null, 1000.0, 50);        

        LisaaPalloja(10);
    }

    void LisaaPalloja(int maara)
    {
        for (int i = 0; i < maara; i++)
        {
            var pallo = new PhysicsObject(50, 50, Shape.Circle);
            pallo.Restitution = 0.99;
            pallo.LinearDamping = 0.99;
            pallo.AngularDamping = 0.99;
            pallo.X = RandomGen.NextDouble(Level.Left + 50, Level.Right - 50);
            pallo.Y = RandomGen.NextDouble(Level.Bottom + 50, Level.Top - 50);
            pallo.Color = RandomGen.NextColor();
            Add(pallo);
            pallot.Add(pallo);
        }
    }

    void MuutaPainoVoimanSuunta(AnalogState s)
    {
        Gravity = s.StateVector * 2000;        
    }

    void LyoPalloja(double voima, int taristysAika)
    {
        foreach (PhysicsObject pallo in pallot)
        {
            pallo.Hit(new Vector(RandomGen.NextDouble(-1, 1), RandomGen.NextDouble(-1, 1)) * voima );            
        }
        Phone.Vibrate(taristysAika);
    }    
}