﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;
using Jypeli.Controls;
using Jypeli.Widgets;
using Jypeli.WP7;

public class Peli : PhysicsGame
{

    int askeleet;
    Label askelNaytto;
    bool odottaaNollausta;

    public override void Begin()
    {
        Phone.DisplayOrientation = DisplayOrientation.Portrait;
        Phone.DisplayResolution = DisplayResolution.Large;                            
        Accelerometer.Listen(AccelerometerDirection.Tap, 0.28, LisaaAskelia, null);
        Accelerometer.Listen(AccelerometerDirection.Shake, VarmistaNollaus, null);
        Level.Background.Image = LoadImage("askelmittari_tausta");
        LisaaNaytto();
    }

    void LisaaNaytto()
    {
        askelNaytto = new Label("0");
        askelNaytto.Font = Font.DefaultLarge;
        askelNaytto.Position = Level.Center + new Vector(0, 40);
        Add(askelNaytto);
    }

    void LisaaAskelia()
    {                
        askeleet += 1;
        askelNaytto.Text = odottaaNollausta ? askelNaytto.Text : "" + askeleet;        
    }

    void VarmistaNollaus()
    {
        Phone.Vibrate(50);
        Action nollaus = odottaaNollausta ? new Action(Nollaa) : new Action(AloitaNollaus);
        nollaus.Invoke();
    }

    void AloitaNollaus()
    {
        askelNaytto.Text = "Nollaa ravistamalla uudelleen.";
        Timer.SingleShot(2, PeruutaNollaus);
        odottaaNollausta = true;
    }

    void Nollaa()
    {
        askeleet = 0;
        Accelerometer.PauseForDuration(1);
        askelNaytto.Text = "0";        
    }

    void PeruutaNollaus()
    {
        askelNaytto.Text = "" + askeleet;
        odottaaNollausta = false;
    }
}