﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;
using Jypeli.Controls;
using Jypeli.WP7;

public class Peli : PhysicsGame
{
    Jypeli.WP7.Camera camera;
    PhysicsObject kuva;
    int pyorimisSuunta = 1;

    public override void Begin()
    {
        camera = new Jypeli.WP7.Camera();

        Phone.DisplayOrientation = DisplayOrientation.LandscapeLeft;        
        Level.Width = 800;
        Level.Height = 480;
        Level.CreateBorders();
        Level.Background.Image = Image.FromColor(800, 480, Color.Black);
        Camera.ZoomToLevel();

        Accelerometer.ListenAnalog(MuutaPV, null);
        Accelerometer.Listen(AccelerometerDirection.Tap, PyoraytaKuvaa, null);
        Accelerometer.Listen(AccelerometerDirection.Shake, ValitseKuva, null);
        TouchPanel.Listen(ButtonState.Pressed, OtaKuva, null);

        kuva = new PhysicsObject(400, 270, Shape.Rectangle);
        Add(kuva);

        // Kameran tapahtumankäsittelijät ja asetukset.
        camera.PhotoReady += MuutaKuva;
        camera.ShowCameraWhenChoosingPhoto = true;
        camera.SavePhotos = true;
        camera.SaveName = "KameraTestiKuva";
    }

    void MuutaKuva(Image photo)
    {
        kuva.Image = photo;
    }

    void ValitseKuva()
    {
        Phone.Vibrate(50);
        camera.ChoosePhoto();
    }

    void OtaKuva(Touch t)
    {
        Phone.Vibrate(50);
        camera.TakePhoto();
    }

    void MuutaPV(AnalogState s)
    {
        Gravity = s.StateVector * 200;
    }

    void PyoraytaKuvaa()
    {
        pyorimisSuunta *= -1;
        kuva.AngularVelocity = 0;
        kuva.ApplyTorque(pyorimisSuunta * 1000000);
    }
}