﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;
using Jypeli.Controls;
using Jypeli.WP7;
using Jypeli.Widgets;

public class Peli : PhysicsGame
{
    Label data;
    Label status;
    GPS gps;

    public override void Begin()
    {
        gps = new GPS();

        Phone.DisplayOrientation = DisplayOrientation.Portrait;
        Phone.DisplayResolution = DisplayResolution.Large;
        Accelerometer.Listen(AccelerometerDirection.Shake, Nollaa, null);
        Level.BackgroundColor = Color.Black;

        status = new Label("GPS-Status");
        status.HorizontalAlignment = HorizontalAlignment.Center;
        status.Position = Level.Center + new Vector(0, 350);
        status.TextColor = Color.White;
        Add(status);

        data = new Label("no data");
        data.HorizontalAlignment = HorizontalAlignment.Left;
        data.Position = Level.Center + new Vector(5, 50);
        data.SizeMode = TextSizeMode.Wrapped;
        data.Font = Font.DefaultSmallBold;
        data.TextColor = Color.White;
        data.Width = 480;               
        Add(data);

        // GPS-tapahtumankäsittelijät ja päälle laitto.
        gps.GpsStatusChanged += MuutaStatus;
        gps.GpsDataAvailable += PaivitaData;
        gps.Start();
        
    }

    void MuutaStatus(string tila)
    {
        status.Text = "GPS: " + tila;
    }

    void PaivitaData()
    {
        Phone.Vibrate(50);

        string error = "Dataa ei saatavilla";
      
        string pituuspiiri = gps.Longitude.IsDataAvailable() ? gps.Longitude.ToString() : error;
        string leveyspiiri = gps.Latitude.IsDataAvailable() ? gps.Latitude.ToString() : error;
        string nopeusMS = gps.Speed.IsDataAvailable() ? gps.Speed.ToString() : error;
        string nopeusKMH = gps.SpeedKMH.IsDataAvailable() ? gps.SpeedKMH.ToString() : error;
        string nopeusMPH = gps.SpeedMPH.IsDataAvailable() ? gps.SpeedMPH.ToString() : error;
        string suunta = gps.Course.IsDataAvailable() ? gps.Course.ToString() : error;
        string korkeus = gps.Altitude.IsDataAvailable() ? gps.Altitude.ToString() : error;

        StringBuilder t = new StringBuilder();
        
        t.AppendLine("Pituuspiiri");
        t.AppendLine(TeeRivinVaihto(pituuspiiri));
        t.AppendLine();

        t.AppendLine("Leveyspiiri");
        t.AppendLine(TeeRivinVaihto(leveyspiiri));
        t.AppendLine();

        t.AppendLine("Nopeus m/s");
        t.AppendLine(TeeRivinVaihto(nopeusMS));
        t.AppendLine();

        t.AppendLine("Nopeus-km/h");
        t.AppendLine(TeeRivinVaihto(nopeusKMH));
        t.AppendLine();

        t.AppendLine("Nopeus-mph");
        t.AppendLine(TeeRivinVaihto(nopeusMPH));
        t.AppendLine();

        t.AppendLine("Suuntakulma");
        t.AppendLine(TeeRivinVaihto(suunta));
        t.AppendLine();

        t.AppendLine("Korkeus merenpinnasta");
        t.AppendLine(TeeRivinVaihto(korkeus));

        data.Text = t.ToString();
    }

    string TeeRivinVaihto(string teksti)
    {
        return teksti.Replace("Avg", "\nAvg");
    }

    void Nollaa()
    {
        gps.ResetAll(true);
    }
}
