﻿using Microsoft.Xna.Framework;

/*
 * Authors: Jaakko Kosonen 
 */

namespace WindowsPhoneGame
{
    /// <summary>
    /// Event arguments for collision.
    /// </summary>
    public class CollisionEventArgs
    {
        private Vector2 position;
        /// <summary>
        /// Position of collision.
        /// </summary>
        public Vector2 Position
        {
            get { return position; }
        }

        private CollisionType type;
        /// <summary>
        /// Type of collision.
        /// </summary>
        public CollisionType Type
        {
            get { return type; }
        }

        /// <summary>
        /// Constructor.
        /// </summary>
        /// <param name="position">Position of collision</param>
        /// <param name="type">Type of collision</param>
        public CollisionEventArgs(Vector2 position, CollisionType type)
        {
            this.position = position;
            this.type = type;
        }
    }
}
