﻿
/*
 * Authors: Jaakko Kosonen 
 */

namespace WindowsPhoneGame
{   
    /// <summary>
    /// Delegate for handling collisions.
    /// </summary>
    /// <param name="sender">Sender</param>
    /// <param name="e">Collision event arguments</param>
    public delegate void CollisionEvent(object sender, CollisionEventArgs e);

    /// <summary>
    /// Abstract class for handling a collision.
    /// </summary>
    abstract class CollisionEventHandler
    {
        /// <summary>
        /// Collision hanling method.
        /// </summary>
        /// <param name="sender">Sender</param>
        /// <param name="e">Collision event arguments</param>
        public abstract void HandleCollision(object sender, CollisionEventArgs e);
    }

    /// <summary>
    /// Enumeration for different types of collisions.
    /// </summary>
    public enum CollisionType
    {
        BallAndPaddle,
        BallAndTopOrBottomLevelBorder,
        BallAndLeftLevelBorder,
        BallAndRightLevelBorder,
        Unknown
    }
}