using System;
using Microsoft.Xna.Framework;

/*
 * Authors: Jaakko Kosonen 
 */

namespace WindowsPhoneGame
{
    /// <summary>
    /// AI-opponent for pong-game.
    /// Not quite ready yet.
    /// </summary>
    class PongAI
    {
        private float yCoordinateGuess;
        private int skillLevel;
        private Random random;

        /// <summary>
        /// Constructor.
        /// </summary>
        /// <param name="skill">Skill level of AI (0-100)</param>
        public PongAI(int skill)
        {
            skillLevel = (Int32)MathHelper.Clamp(skill, 0, 10) * 10;
            random = new Random();
        }

        /// <summary>
        /// Guesses the position of ball.
        /// </summary>
        /// <param name="ball">Pong-ball</param>
        public void Observe(PongBall ball)
        {
            if (ball.Position.X < 90 || ball.Position.X > 710) return;
            int bestGuess = (Int32)ball.Position.Y;
            int r = random.Next(bestGuess - (100 - skillLevel), bestGuess + (100 - skillLevel));
            if (Math.Abs(yCoordinateGuess - r) > skillLevel / 2)
                yCoordinateGuess = r;
             
            //yCoordinateGuess = ball.Position.Y;
        }

        /// <summary>
        /// Moves the paddle.
        /// </summary>
        /// <param name="paddle">Pong-paddle</param>
        public void Act(PongPaddle paddle)
        {
            paddle.YcoordinateGoal = yCoordinateGuess;
        }
    }
}
