﻿using AdvanceMath;
using Jypeli;
using Jypeli.Controls;

public class Peli : PhysicsGame
{
    public override void Begin()
    {
        Camera.ZoomToLevel();

        PhysicsObject p1 = new PhysicsObject( 200.0, 200.0, Shape.Circle );
        p1.Mass = 10.0;
        p1.X = 0.0;
        p1.Y = Level.Bottom + 200.0;
        //Add( p1 );

        PhysicsObject p2 = new PhysicsObject( 100.0, 100.0, Shape.Circle );
        p2.Mass = 20.0;
        p2.X = 0.0;
        p2.Y = Level.Bottom + 350.0;
        //Add( p2 );

        PhysicsObject p3 = new PhysicsObject( 60.0, 60.0, Shape.Circle );
        p3.Mass = 30.0;
        p3.X = 0.0;
        p3.Y = Level.Bottom + 430.0;
        //Add( p3 );

        PhysicsStructure ukko = new PhysicsStructure( p1, p2, p3 );
        ukko.Softness = 4;
        Add( ukko );

        Level.CreateBorders();
        Gravity = new Vector( 0, -400 );

        Timer t = new Timer();
        t.Interval = 0.2;
        t.Timeout += VaihdaPainovoimaa;
        t.Start();

        Keyboard.Listen( Key.Escape, ButtonState.Pressed, Exit, "Poistu" );
    }

    void VaihdaPainovoimaa()
    {
        Gravity = Vector.FromLengthAndAngle( Gravity.Magnitude, Gravity.Angle + Angle.FromRadians( 0.1 ) );
    }
}
