﻿using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Controls;
using Jypeli.ScreenObjects;
using Jypeli.Assets;

namespace Muistipeli
{
    public class Peli : Game
    {
        List<Kortti> kortit = new List<Kortti>();
        double kortinLeveys = 80;
        double kortinKorkeus = 100;
        int montakoKorttia;
        int korostettuKortti;
        int montakoKorttiaRiviin;

        public enum Suunta { Vasen, Oikea, Ylos, Alas }

        Kortti kortti1;

        //public override void Begin()
        //{
        //    kortti1 = new Kortti(80, 100);
        //    Add(kortti1);
        //    AsetaNappaimet();

        //}

        public override void Begin()
        {
            montakoKorttia = 50;
            TeeKortit();
            AsetaNappaimet();
            KortitRuudulle(kortit);
            ValitseEnsimmainen();
        }

        void ValitseEnsimmainen()
        {
            KorostaKortti(kortit.Count / 2);
            korostettuKortti = kortit.Count / 2;
        }

        int KortinNumeronTarkistus(int kortinNro)
        {
            if (kortinNro < 0)
            {
                kortinNro = kortit.Count - 1;
            }

            if (kortinNro > kortit.Count - 1) // Hypätään viimeisestä kortista oikealle
            {
                kortinNro--; // "Palataan viimeiseen korttiin"
                //kortinNro = 0;
                int jj = kortit.Count % (montakoKorttiaRiviin + 1); // Montako korttia viimeisellä rivillä on
                kortinNro = kortit.Count - jj; // Siirrytään viimeisen rivin ensimmäiseen korttiin
            }

            return kortinNro;
        }

        void KorostaKortti(int kortinNro)
        {
            kortinNro = KortinNumeronTarkistus(kortinNro);
            Kortti.PuoliEsilla puoliesilla = kortit[kortinNro].KumpiPuoliEsilla();
            if (puoliesilla == Kortti.PuoliEsilla.Taka)
            {
                double punainen = kortit[kortinNro].Color.RedComponent;                
                double sininen = kortit[kortinNro].Color.BlueComponent;
                double vihrea= kortit[kortinNro].Color.GreenComponent;


                kortit[kortinNro].Color = new Color(
                    punainen + 0.5,
                    sininen+ 0.5,
                    vihrea + 0.5);
                korostettuKortti = kortinNro;
            }
            else
            {
                kortit[kortinNro].Color = Color.Gray;
                korostettuKortti = kortinNro;
            }
        }

        //void PoistaKorostus(int kortinNro)
        //{
        //    kortinNro = KortinNumeronTarkistus(kortinNro);

        //    Kortti.PuoliEsilla puoliesilla = kortit[kortinNro].KumpiPuoliEsilla();
        //    if (puoliesilla == Kortti.PuoliEsilla.Kuva)
        //    {
        //        kortit[kortinNro].Color = kortit[kortinNro].kuvapuoliVari;
        //    }
        //    if (puoliesilla == Kortti.PuoliEsilla.Taka)
        //    {
        //        kortit[kortinNro].Color = kortit[kortinNro].takaVari;
        //    }

        //}

        void AsetaNappaimet()
        {
            Keyboard.Listen(Key.Left, ButtonState.Pressed, KortinValinta, null, Suunta.Vasen);
            Keyboard.Listen(Key.Right, ButtonState.Pressed, KortinValinta, null, Suunta.Oikea);
            Keyboard.Listen(Key.Up, ButtonState.Pressed, KortinValinta, null, Suunta.Ylos);
            Keyboard.Listen(Key.Down, ButtonState.Pressed, KortinValinta, null, Suunta.Alas);
            Keyboard.Listen(Key.Space, ButtonState.Pressed, KaannaKortti, null);
            Keyboard.Listen(Key.Escape, ButtonState.Pressed, Lopeta, null);
        }

        void Lopeta()
        {
            Exit();
        }

        void KaannaKortti()
        {
            kortit[korostettuKortti].Kaanna();
        }

        void KortinValinta(Suunta suunta)
        {
            bool rivinAlussa = false;
            bool rivinLopussa = false;
            if (korostettuKortti % (montakoKorttiaRiviin + 1) == 0)
                rivinAlussa = true;
            if ((korostettuKortti + 1) % (montakoKorttiaRiviin + 1) == 0)
                rivinLopussa = true;


            if (suunta == Suunta.Vasen)
            {
                PoistaKorostus(korostettuKortti);
                if (rivinAlussa)
                {
                    KorostaKortti(korostettuKortti + montakoKorttiaRiviin);
                    MessageDisplay.Add("Korostettu kortti: " + korostettuKortti);
                    return;
                }
                KorostaKortti(--korostettuKortti);
                MessageDisplay.Add("Korostettu kortti: " + korostettuKortti);

            }

            if (suunta == Suunta.Oikea)
            {
                PoistaKorostus(korostettuKortti);
                if (rivinLopussa)
                {
                    KorostaKortti(korostettuKortti - montakoKorttiaRiviin);
                    MessageDisplay.Add("Korostettu kortti: " + korostettuKortti);

                    return;
                }
                KorostaKortti(++korostettuKortti);
                MessageDisplay.Add("Korostettu kortti: " + korostettuKortti);

            }

            if (suunta == Suunta.Ylos)
            {
                PoistaKorostus(korostettuKortti);
                KorostaKortti(korostettuKortti - montakoKorttiaRiviin - 1);
                MessageDisplay.Add("Korostettu kortti: " + korostettuKortti);

            }

            if (suunta == Suunta.Alas)
            {
                PoistaKorostus(korostettuKortti);
                KorostaKortti(korostettuKortti + montakoKorttiaRiviin + 1);
                MessageDisplay.Add("Korostettu kortti: " + korostettuKortti);

            }
            //MessageDisplay.Add(montakoKorttiaRiviin.ToString());
            //MessageDisplay.Add((korostettuKortti % (montakoKorttiaRiviin +1)).ToString());
        }

        void TeeKortit()
        {
            for (int i = 0; i < montakoKorttia; i++)
            {
                TeeKortti();
            }
        }

        private void KortitRuudulle(List<Kortti> kortit)
        {
            int montakoKorttia = kortit.Count;
            //int montakoKorttiaRiviin = 8;
            montakoKorttiaRiviin = (int)Math.Sqrt(kortit.Count);
            montakoKorttiaRiviin = (int)Math.Floor((3.0 / 2.0) * montakoKorttiaRiviin);
            int montakoRivia = (kortit.Count / montakoKorttiaRiviin);

            int i = 0;
            int rivi = 1;
            int rivilla = 0;
            foreach (GameObject kortti in kortit)
            {
                Add(kortti);
                //kortti.X = (-(montakoKorttia * (kortinLeveys + 20)) / 2) + (i * (kortinLeveys + 20));
                kortti.X = (-(montakoKorttiaRiviin * (kortinLeveys + 20)) / 2) + (rivilla * (kortinLeveys + 20));
                kortti.Y = ((montakoRivia+1) * (kortinKorkeus + 20)) / 2 - rivi * (kortinKorkeus + 20);
                i++;
                rivilla++;
                if (rivilla > montakoKorttiaRiviin)
                {
                    rivi++;
                    rivilla = 0;
                }
            }
        }

        void TeeKortti()
        {
            //GameObject kortti = new GameObject(kortinLeveys, kortinKorkeus, Shape.Rectangle);
            //kortti.Color = Color.White;

            //Kortti kortti = new Kortti(kortinLeveys, kortinKorkeus, true, Color.White, Color.Red);
            //kortit.Add(kortti);
        }
    }
}