using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Effects;
using Jypeli.Widgets;

public class Peli : PhysicsGame
{
    Vector nopeusYlos = new Vector( 0, 200 );
    Vector nopeusAlas = new Vector( 0, -200 );

    PhysicsObject pallo;
    PhysicsObject maila1;
    PhysicsObject maila2;

    public override void Begin()
    {
        LuoKentta();
        AsetaOhjaimet();
        AloitaPeli();
    }

    void LuoKentta()
    {
        pallo = new PhysicsObject( 40.0, 40.0 );
        pallo.Shape = Shape.Circle;
        pallo.X = -200.0;
        pallo.Y = 0.0;
        pallo.Restitution = 1.0;
        Add( pallo );

        maila1 = LuoMaila( Level.Left + 20.0, 0.0 );
        maila2 = LuoMaila( Level.Right - 20.0, 0.0 );

        Level.CreateBorders( 1.0, false );
        Level.BackgroundColor = Color.Black;

        Camera.ZoomToLevel();
    }

    PhysicsObject LuoMaila( double x, double y )
    {
        PhysicsObject maila = PhysicsObject.CreateStaticObject( 20.0, 100.0 );
        maila.Shape = Shape.Rectangle;
        maila.X = x;
        maila.Y = y;
        maila.Restitution = 1.0;
        Add( maila );
        return maila;
    }

    void AloitaPeli()
    {
        Vector impulssi = new Vector( 500.0, 0.0 );
        pallo.Hit( impulssi );
    }

    void AsetaOhjaimet()
    {
        Keyboard.Listen( Key.A, ButtonState.Down, AsetaNopeus, "Pelaaja 1: Liikuta mailaa yls", maila1, nopeusYlos );
        Keyboard.Listen( Key.A, ButtonState.Released, AsetaNopeus, null, maila1, Vector.Zero );
        Keyboard.Listen( Key.Z, ButtonState.Down, AsetaNopeus, "Pelaaja 1: Liikuta mailaa alas", maila1, nopeusAlas );
        Keyboard.Listen( Key.Z, ButtonState.Released, AsetaNopeus, null, maila1, Vector.Zero );

        Keyboard.Listen( Key.Up, ButtonState.Down, AsetaNopeus, "Pelaaja 2: Liikuta mailaa yls", maila2, nopeusYlos );
        Keyboard.Listen( Key.Up, ButtonState.Released, AsetaNopeus, null, maila2, Vector.Zero );
        Keyboard.Listen( Key.Down, ButtonState.Down, AsetaNopeus, "Pelaaja 2: Liikuta mailaa alas", maila2, nopeusAlas );
        Keyboard.Listen( Key.Down, ButtonState.Released, AsetaNopeus, null, maila2, Vector.Zero );

        Keyboard.Listen( Key.F1, ButtonState.Pressed, ShowControlHelp, "Nyt ohjeet" );
        Keyboard.Listen( Key.Escape, ButtonState.Pressed, Exit, "Poistu" );

        ControllerOne.Listen( Button.DPadUp, ButtonState.Down, AsetaNopeus, "Liikuta mailaa yls", maila1, nopeusYlos );
        ControllerOne.Listen( Button.DPadUp, ButtonState.Released, AsetaNopeus, null, maila1, Vector.Zero );
        ControllerOne.Listen( Button.DPadDown, ButtonState.Down, AsetaNopeus, "Liikuta mailaa alas", maila1, nopeusAlas );
        ControllerOne.Listen( Button.DPadDown, ButtonState.Released, AsetaNopeus, null, maila1, Vector.Zero );

        ControllerTwo.Listen( Button.DPadUp, ButtonState.Down, AsetaNopeus, "Liikuta mailaa yls", maila2, nopeusYlos );
        ControllerTwo.Listen( Button.DPadUp, ButtonState.Released, AsetaNopeus, null, maila2, Vector.Zero );
        ControllerTwo.Listen( Button.DPadDown, ButtonState.Down, AsetaNopeus, "Liikuta mailaa alas", maila2, nopeusAlas );
        ControllerTwo.Listen( Button.DPadDown, ButtonState.Released, AsetaNopeus, null, maila2, Vector.Zero );

        ControllerOne.Listen( Button.Back, ButtonState.Pressed, Exit, "Poistu" );
        ControllerTwo.Listen( Button.Back, ButtonState.Pressed, Exit, "Poistu" );
    }

    void AsetaNopeus( PhysicsObject maila, Vector nopeus )
    {
        if ( (nopeus.Y < 0) && (maila.Bottom < Level.Bottom) )
        {
            maila.Velocity = Vector.Zero;
            return;
        }
        if ( (nopeus.Y > 0) && (maila.Top > Level.Top) )
        {
            maila.Velocity = Vector.Zero;
            return;
        }

        maila.Velocity = nopeus;
    }
}
