﻿#region Usings
using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Widgets;
using Jypeli.Assets;
using Jypeli.WP7;
using Jypeli.Effects;
#endregion

namespace Rampege
{
    public class Peli : PhysicsGame
    {
        public event Action PeliPaattyi;

        protected virtual void OnPeliPaattyi()
        {
            peliKaynnissa = false;
            IsMouseVisible = true;
            NaytaLista(pistelaskuri.Value);

            if (PeliPaattyi != null)
            {
                PeliPaattyi();
            }
        }

        public event Action KenttaAlkaa;
        protected virtual void OnKenttaAlkaa()
        {
            if (KenttaAlkaa != null)
            {
                peliKaynnissa = true;
                KenttaAlkaa();
            }
        }

        public event Action KenttaLapi;
        protected virtual void OnKenttaLapi()
        {
            if (KenttaLapi != null)
            {
                KenttaLapi();
                peliKaynnissa = false;
                Widget kenttaLapiWidget = new Widget(600, 200);
                kenttaLapiWidget.X = 0;
                kenttaLapiWidget.Y = 0;
                kenttaLapiWidget.BorderColor = Color.White;
                Color c = Color.White;
                c.AlphaComponent = 200;
                kenttaLapiWidget.Color = c;
                Add(kenttaLapiWidget);
                KenttaAlkaa += kenttaLapiWidget.Destroy;
                PeliPaattyi += kenttaLapiWidget.Destroy;

                // Päästiin läpi viimeinen kenttä
                if (KenttiaYhteensa <= kenttalaskuri.Value)
                {
                    OnPeliLapi();
                    return;
                }

                Label kenttaLapiTeksti = new Label("Great! You passed LEVEL number " + kenttalaskuri + ".\nYou have " + pistelaskuri.Value + " points\nTap the screen to start next LEVEL...");
                kenttaLapiTeksti.SizeMode = TextSizeMode.StretchText;
                kenttaLapiTeksti.Size *= 1.5;
                kenttaLapiTeksti.Position = new Vector(-kenttaLapiTeksti.Width / 6, 25);
                kenttaLapiWidget.Add(kenttaLapiTeksti);

                KenttaAlkaa += kenttaLapiTeksti.Destroy;
                PeliPaattyi += kenttaLapiWidget.Destroy;
                PeliPaattyi += kenttaLapiTeksti.Destroy;

                Keyboard.Listen(Key.Enter, ButtonState.Pressed, delegate { Keyboard.Disable(Key.Enter); SeuraavaKentta(++(kenttalaskuri.Value)); TeeRampe(); }, null);
                TouchPanel.Listen(ButtonState.Pressed, delegate { TouchPanel.Disable(ButtonState.Pressed); SeuraavaKentta(++(kenttalaskuri.Value)); TeeRampe(); }, null);

            }
        }

        public event Action PeliLapi;
        protected virtual void OnPeliLapi()
        {
            if (PeliLapi != null)
            {
                PeliLapi();
                pistelaskuri.Value += 1000 * elamalaskuri.Value;
                Label peliLapiTeksti = new Label("Congratulations!\nYou are the KING of this game!\nYou got " + pistelaskuri.Value + " points.");
                peliLapiTeksti.SizeMode = TextSizeMode.StretchText;
                peliLapiTeksti.Size *= 1.5;
                peliLapiTeksti.Position = new Vector(-peliLapiTeksti.Width / 6, 25);
                Add(peliLapiTeksti);
                PeliPaattyi += peliLapiTeksti.Destroy;

                TouchPanel.Listen(ButtonState.Pressed, delegate { OnPeliPaattyi(); }, null);
            }
        }

        PhysicsObject rampe;
        const int Koko = 40;
        const int PisteitaBobosta = 100;
        const int PisteitaKentasta = 1000;
        const int KenttiaYhteensa = 8;
        int aikaPerKentta = 30;
        Vector AloitusPaikka;
        IntMeter pistelaskuri;
        IntMeter elamalaskuri;
        IntMeter aikalaskuri;
        IntMeter kenttalaskuri = new IntMeter(1);
        Timer aikalaskuriAjastin;

        bool peliKaynnissa = true;
        ScoreList top10 = new ScoreList(10, false, -1);

        Image tiilikuva = LoadImage("tiili");
        Image bobokuva = LoadImage("bobo");
        Image piikkikuva = LoadImage("piikki");
        Image maalikuva = LoadImage("ruutulippu");
        Image alkukuva1 = LoadImage("alkukuva");
        Image alkukuva2 = LoadImage("alkukuva_");

        ExplosionSystem explosionSystem = new ExplosionSystem(LoadImage("bobo"), 30);

        public override void Begin()
        {
            ClearAll();

            Phone.DisplayResolution = DisplayResolution.Large;

#if WINDOWS
            SetWindowSize(800, 480, false);
#endif
            GameObject tausta = new GameObject(800, 480);
            tausta.Image = alkukuva1;
            Add(tausta);

            MediaPlayer.Play("alkumusa");
            MediaPlayer.IsRepeating = true;

            IsMouseVisible = true;
            Mouse.Listen(MouseButton.Left, ButtonState.Pressed, delegate() { tausta.Image = alkukuva2; }, null);
            Mouse.Listen(MouseButton.Left, ButtonState.Released, AloitaPeli, null);
            TouchPanel.Listen(ButtonState.Pressed, delegate(Touch t) { tausta.Image = alkukuva2; }, null);
            TouchPanel.Listen(ButtonState.Released, delegate(Touch t) { AloitaPeli(); }, null);
            Keyboard.Listen(Key.Space, ButtonState.Released, AloitaPeli, null);
            PhoneBackButton.Listen(Exit, null);
        }

        public override void Continue()
        {
            Begin();
        }

        void AloitaPeli()
        {
            Mouse.Clear();
            Keyboard.Clear();
            TouchPanel.Clear();
            MediaPlayer.Play("pelimusa");
            MediaPlayer.IsRepeating = true;

            /* Jätetään aikalaskuri toistaiseksi pois
             * aikalaskuriAjastin = new Timer();
             * aikalaskuriAjastin.Interval = 1;
             * aikalaskuriAjastin.Trigger += delegate { aikalaskuri.Value--; };
             */

            peliKaynnissa = true;
            Gravity = new Vector(0, -500);
            LaskuritJaNaytot();
            Kontrollit();
            SeuraavaKentta(1);
            TeeRampe();


            if (DataStorage.Exists("Top10Rampege.xml"))
                top10 = DataStorage.Load<ScoreList>(top10, "Top10Rampege.xml");

        }

        void AsetaRajahdykset()
        {
            explosionSystem = new ExplosionSystem(LoadImage("bobo_hover"), 100); Add(explosionSystem);
            explosionSystem.MinScale = 15;
            explosionSystem.MaxScale = 25;
            explosionSystem.MinLifetime = 0.5;
            explosionSystem.MaxLifetime = 0.5;
            explosionSystem.MinVelocity = 200;
            explosionSystem.MaxVelocity = 200;
            explosionSystem.BlendMode = BlendMode.Alpha;
        }

        void KenttaPaastyLapi()
        {

            /* aikalaskuriAjastin.Stop(); // Pois toistaiseksi */
            // Päästiin viimeinen kenttä läpi
        }

        void SeuraavaKentta(int kenttanro)
        {
            OnKenttaAlkaa();
            // aikalaskuri.Reset();
            // aikalaskuriAjastin.Start();
            ClearGameObjects();
            TeeKentta(kenttanro);
            AsetaRajahdykset();
        }

        #region Kenttä ja pelihahmo

        void TeeKentta(int kenttanro)
        {
            TileMap ruudut = TileMap.FromLevelAsset("kentta" + kenttanro);
            ruudut.SetTileMethod('t', LuoTiili);
            ruudut.SetTileMethod('r', LuoRampenpaikka);
            ruudut.SetTileMethod('b', LuoBobo);
            ruudut.SetTileMethod('p', LuoPiikki);
            ruudut.SetTileMethod('m', LuoMaali);
            ruudut.Execute(Koko, Koko);
        }

        void TeeRampe()
        {
            rampe = new PhysicsObject(20, 20, Shape.Circle);
            Image rampekuva = LoadImage("Rampe");
            rampe.Image = rampekuva;
            rampe.Position = AloitusPaikka;
            Add(rampe);
            AddCollisionHandler(rampe, RampeTormasi);
        }

        void LuoMaali(Vector paikka, double leveys, double korkeus)
        {
            PhysicsObject maali = PhysicsObject.CreateStaticObject(Koko, Koko);
            maali.Position = paikka;
            maali.Tag = "maali";
            maali.Image = maalikuva;
            Add(maali);
        }

        void LuoTiili(Vector paikka, double leveys, double korkeus)
        {
            PhysicsObject tiili = PhysicsObject.CreateStaticObject(Koko, Koko);
            tiili.Position = paikka;
            tiili.Tag = "tiili";
            tiili.Image = tiilikuva;
            Add(tiili);
        }

        void LuoBobo(Vector paikka, double leveys, double korkeus)
        {
            PhysicsObject bobo = PhysicsObject.CreateStaticObject(Koko, Koko);
            bobo.Position = paikka;
            bobo.Tag = "bobo";
            bobo.Image = bobokuva;
            Add(bobo);
        }

        void LuoPiikki(Vector paikka, double leveys, double korkeus)
        {
            PhysicsObject piikki = PhysicsObject.CreateStaticObject(Koko, Koko);
            piikki.Position = paikka;
            piikki.Tag = "piikki";
            piikki.Image = piikkikuva;
            Add(piikki);
        }

        void LuoRampenpaikka(Vector paikka, double leveys, double korkeus)
        {
            AloitusPaikka = paikka;
        }
        #endregion

        #region Laskurit, näytöt, käyttöliittymä

        void KontekstiMenu()
        {
            peliKaynnissa = false;

            PhoneBackButton.Listen(Exit, null);
            Keyboard.Listen(Key.Escape, ButtonState.Pressed, Exit, null);

            Widget w = new Widget(600, 200);
            w.X = 0;
            w.Y = 0;
            w.BorderColor = Color.White;
            Color c = Color.Gray;
            w.Image = LoadImage("tiilitausta");
            c.AlphaComponent = 200;
            w.Color = c;
            Add(w);

            Label menuitem1 = new Label(300, 80);
            menuitem1.Image = LoadImage("restart");
            menuitem1.Y = 40;
            Add(menuitem1);

            Label menuitem2 = new Label(300, 80);
            menuitem2.Image = LoadImage("quit");
            menuitem2.Y = -40;
            Add(menuitem2);

            // Aloita level alusta
            TouchPanel.ListenOn(menuitem1, ButtonState.Down, delegate { menuitem1.Image = LoadImage("restart_"); }, null);
            TouchPanel.ListenOn(menuitem1, ButtonState.Released, delegate
            {
                w.Destroy();
                menuitem1.Destroy();
                menuitem2.Destroy();
                TouchPanel.Clear();
                PhoneBackButton.Clear();
                elamalaskuri.Value--;
                SeuraavaKentta(kenttalaskuri.Value);
                TeeRampe();
                peliKaynnissa = true;
            }, null);

            // Poistu pelistä
            TouchPanel.ListenOn(menuitem2, ButtonState.Down, delegate { menuitem2.Image = LoadImage("quit_"); }, null);
            TouchPanel.ListenOn(menuitem2, ButtonState.Released, delegate { Exit(); }, null);
        }

        void LaskuritJaNaytot()
        {
            Widget pistelaskuriWidget = new Widget(238, 37);
            pistelaskuriWidget.Right = Screen.RightSafe - 1;
            pistelaskuriWidget.Top = Screen.TopSafe - 1;
            pistelaskuriWidget.BorderColor = Color.White;
            Color c = Color.White;
            c.AlphaComponent = 200;
            pistelaskuriWidget.Color = c;
            Add(pistelaskuriWidget);
            pistelaskuri = new IntMeter(0);
            Label pisteNaytto = new Label();
            pisteNaytto.Title = "Points";
            pisteNaytto.Right = Screen.RightSafe - 150;
            pisteNaytto.Top = Screen.TopSafe - 2;
            pisteNaytto.BindTo(pistelaskuri);
            pisteNaytto.SizeMode = TextSizeMode.StretchText;
            pisteNaytto.Size *= 1.5;
            Add(pisteNaytto);

            Widget elamalaskuriWidget = new Widget(135, 37);
            elamalaskuriWidget.Left = Screen.LeftSafe + 1;
            elamalaskuriWidget.Top = Screen.TopSafe - 1;
            elamalaskuriWidget.BorderColor = Color.White;
            elamalaskuriWidget.Color = c;
            Add(elamalaskuriWidget);
            Label elamaNaytto = new Label();
            elamalaskuri = new IntMeter(3);
            elamalaskuri.MinValue = 0;
            elamaNaytto.Title = "Lives";
            elamaNaytto.Left = Screen.LeftSafe + 14;
            elamaNaytto.Top = Screen.TopSafe - 2;
            elamaNaytto.BindTo(elamalaskuri);
            elamaNaytto.SizeMode = TextSizeMode.StretchText;
            elamaNaytto.Size *= 1.5;
            Add(elamaNaytto);

            Widget kenttaNroWidget = new Widget(60, 37);
            kenttaNroWidget.Top = Screen.TopSafe - 1;
            kenttaNroWidget.X = 0;
            kenttaNroWidget.BorderColor = Color.White;
            kenttaNroWidget.Color = c;
            Add(kenttaNroWidget);
            Label kenttaNroNaytto = new Label();
            kenttaNroNaytto.Title = "";
            kenttaNroNaytto.Top = Screen.TopSafe - 2;
            kenttaNroNaytto.BindTo(kenttalaskuri);
            kenttaNroNaytto.SizeMode = TextSizeMode.StretchText;
            kenttaNroNaytto.Size *= 1.5;
            kenttaNroNaytto.X = -kenttaNroNaytto.Width / 6;
            Add(kenttaNroNaytto);

            PeliPaattyi += kenttaNroWidget.Destroy;
            PeliPaattyi += kenttaNroNaytto.Destroy;
            PeliPaattyi += elamalaskuriWidget.Destroy;
            PeliPaattyi += elamaNaytto.Destroy;
            PeliPaattyi += pistelaskuriWidget.Destroy;
            PeliPaattyi += pisteNaytto.Destroy;

            PeliLapi += kenttaNroWidget.Destroy;
            PeliLapi += kenttaNroNaytto.Destroy;
            PeliLapi += elamalaskuriWidget.Destroy;
            PeliLapi += elamaNaytto.Destroy;
            PeliLapi += pistelaskuriWidget.Destroy;
            PeliLapi += pisteNaytto.Destroy;

            #region Aikalaskuri (toistaiseksi pois käytöstä)
            /* Widget aikalaskuriWidget = new Widget(60, 37);
            aikalaskuriWidget.Bottom = Screen.BottomSafe + 2;
            aikalaskuriWidget.BorderColor = Color.White;
            aikalaskuriWidget.Color = c;
            Add(aikalaskuriWidget);

            aikalaskuri = new IntMeter(aikaPerKentta);
            aikalaskuri.MinValue = 0;
            aikalaskuri.LowerLimit += AikaLoppui;

            Label aikaNaytto = new Label();
            aikaNaytto.Bottom = Screen.BottomSafe + 8;
            aikaNaytto.BindTo(aikalaskuri);
            aikaNaytto.SizeMode = TextSizeMode.StretchText;
            aikaNaytto.Size *= 1.5;
            Add(aikaNaytto);
            */
            #endregion

            // Kun elämät loppuu niin tuhotaan näytöt ja labelit
            //elamalaskuri.LowerLimit += delegate
            //{
            //    PoistaRuudulta(elamalaskuriWidget);
            //    PoistaRuudulta(elamaNaytto);
            //    PoistaRuudulta(kenttaNroWidget);
            //    PoistaRuudulta(kenttaNroNaytto);
            //    PoistaRuudulta(pistelaskuriWidget);
            //    PoistaRuudulta(pisteNaytto);
            //    PeliPaattyy();
            //};
            elamalaskuri.LowerLimit += delegate { OnPeliPaattyi(); };
            kenttalaskuri.MaxValue = KenttiaYhteensa + 1;
            kenttalaskuri.UpperLimit += delegate { OnPeliLapi(); };
        }

        void AikaLoppui(int i)
        {
            // aikalaskuriAjastin.Stop();
            elamalaskuri.Value--;
            if (elamalaskuri.Value <= elamalaskuri.MinValue) return;
            SeuraavaKentta(kenttalaskuri.Value);
            SoitaAaniefekti("rampekuoli");
            TeeRampe();
        }

        #endregion

        #region Kontrollit ja liikkuminen
        void Kontrollit()
        {
            // ClearControls(); // EI TOIMI 26.7.2011
            Keyboard.Listen(Key.Left, ButtonState.Down, Liikuta, null, new Vector(-700, 0));
            Keyboard.Listen(Key.Right, ButtonState.Down, Liikuta, null, new Vector(700, 0));
            Keyboard.Listen(Key.Space, ButtonState.Down, LiikutaYlos, null);
            Keyboard.Listen(Key.Escape, ButtonState.Pressed, delegate
            {
                TouchPanel.Clear();
                KontekstiMenu();
            }, null);
            //PhoneBackButton.Listen(delegate { TouchPanel.Clear(); KontekstiMenu(); }, null);

            KenttaAlkaa += delegate { PhoneBackButton.Clear(); PhoneBackButton.Listen(delegate { TouchPanel.Clear(); KontekstiMenu(); }, null); };
            KenttaAlkaa += delegate { Keyboard.Enable(Key.Space); };
            KenttaAlkaa += delegate { Keyboard.Enable(Key.Left); };
            KenttaAlkaa += delegate { Keyboard.Enable(Key.Right); };
            KenttaAlkaa += delegate { TouchPanel.Clear(); TouchPanel.Listen(ButtonState.Down, LiikutaYlos, null); };
            KenttaLapi += delegate { Keyboard.Disable(Key.Space); };
            KenttaLapi += delegate { Keyboard.Disable(Key.Left); };
            KenttaLapi += delegate { Keyboard.Disable(Key.Right); };
            KenttaLapi += delegate { TouchPanel.Clear(); };
            KenttaLapi += PhoneBackButton.Clear;

            Accelerometer.Calibration = AccelerometerCalibration.ZeroAngle;
            Accelerometer.ListenAnalog(AccelerometerSensitivity.Realtime, ChangeGravity, null);

            //KenttaLapi += delegate { Accelerometer.DisableAnalog(); };
            //KenttaAlkaa += delegate { Accelerometer.EnableAnalog(); };
        }

        void Liikuta(Vector v)
        {
            rampe.Push(v);
        }

        void LiikutaYlos()
        {
            rampe.Push(new Vector(0, 750));
        }

        void LiikutaYlos(Touch t)
        {
            rampe.Push(new Vector(0, 750));
        }

        void ChangeGravity(AnalogState s)
        {
            Gravity = new Vector(s.StateVector.X * 2000, Gravity.Y);
            //MessageDisplay.Add(s.StateVector.X + " " + s.StateVector.Y);
        }

        #endregion

        void RampeTormasi(PhysicsObject tormaaja, PhysicsObject kohde)
        {
            if (!peliKaynnissa) return;

            if (kohde.Tag.ToString() == "piikki")
            {
                SoitaAaniefekti("rampekuoli");
                Phone.Vibrate(300);
                elamalaskuri.Value--;
                if (elamalaskuri.Value <= elamalaskuri.MinValue) return;
                SeuraavaKentta(kenttalaskuri.Value);
                TeeRampe();
                return;
            }

            if (kohde.Tag.ToString() == "bobo")
            {
                pistelaskuri.Value += PisteitaBobosta;
                kohde.Destroy();
                Phone.Vibrate(100);
                SoitaAaniefekti("bobokeratty");
                explosionSystem.AddEffect(tormaaja.Position, 30);
                return;
            }

            if (kohde.Tag.ToString() == "maali")
            {
                pistelaskuri.Value += PisteitaKentasta;
                elamalaskuri.Value++;
                OnKenttaLapi();
                KenttaPaastyLapi();
                return;
            }

            if (kohde.Tag.ToString() == "tiili")
            {
                if (tormaaja.Velocity.Magnitude > 300)
                {
                    SoitaAaniefekti("tormays");
                    Phone.Vibrate(50);
                }
                return;
            }
        }

        private void SoitaAaniefekti(string p)
        {
            SoundEffect s = LoadSoundEffect(p);
            s.Play();
        }

        void ResetoiLaskurit()
        {
            kenttalaskuri.Reset();
            pistelaskuri.Reset();
            elamalaskuri.Reset();
            // aikalaskuri.Reset();
            // aikalaskuriAjastin.Stop();
        }

        private void NaytaLista(int pisteet)
        {
            HighScoreWindow ikkuna = new HighScoreWindow("Rampege Hall of Fame", "You reached the Top 10, \nenter your name", top10, pisteet);
            ikkuna.Color = Color.White;
            ikkuna.Closed += TallennaPisteet;
            Add(ikkuna);
        }

        void TallennaPisteet(Window ikkuna)
        {
            DataStorage.Save<ScoreList>(top10, "Top10Rampege.xml");
            IsMouseVisible = false;
            LopetaPelaaminen();
        }

        void LopetaPelaaminen()
        {
            ResetoiLaskurit();
            Timer.SingleShot(0.5, Begin);
        }
    }
}
