﻿using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Controls;
using Jypeli.Widgets;


class Menu : Widget
{
    Widget itemList;
    List<Label> items = new List<Label>();
    List<Action> actions = new List<Action>();
    Widget pointer;
    double nextY = 300;
    int selectedIndex = 0;

    public Menu(double width, double height)
        : base(width, height)
    {
        BorderColor = Color.Black;
        Color = Color.Transparent;

        pointer = new Widget(20, 20);
        pointer.Color = Color.Red;
        Add(pointer);

        itemList = new Widget(new VerticalLayout { Spacing = 10 });
        itemList.Color = Color.Transparent;
        Add(itemList);
    }

    public void AddItem(string text, Action actionWhenSelected)
    {
        Label label = new Label(text);
        label.X = 0;
        label.Y = nextY;
        nextY -= label.Height * 2;
        itemList.Add(label);
        items.Add(label);
        actions.Add(actionWhenSelected);
        itemList.RefreshLayout();
        UpdatePointer();
    }

    public void MoveUp()
    {
        if (selectedIndex > 0)
        {
            selectedIndex--;
            UpdatePointer();
        }
    }

    public void MoveDown()
    {
        if (selectedIndex < items.Count - 1)
        {
            selectedIndex++;
            UpdatePointer();
        }
    }

    public void Select()
    {
        actions[selectedIndex]();
    }

    void UpdatePointer()
    {
        pointer.X = -Width / 2 - pointer.Width;
        pointer.Y = items[selectedIndex].Y;
    }
}
