﻿using System;
using Jypeli;
using Jypeli.Controls;
using Jypeli.Widgets;
using Jypeli.Assets;

public class Peli : PhysicsGame
{
    PhysicsObject alus1;
    PhysicsObject alus2;

    PhysicsObject vasenReuna;
    PhysicsObject oikeaReuna;
    PhysicsObject alaReuna;
    PhysicsObject ylaReuna;

    int siirtymaLaidassa = 80;
    int reunanetaisyysruudusta = 100;

    IntMeter p1Pisteet;
    IntMeter p2Pisteet;

    DoubleMeter p1specialTeho;
    DoubleMeter p2specialTeho;

    DoubleMeter p1healthmittari;
    DoubleMeter p2healthmittari;

    Double specialLifeTime = 1.5;
    bool p1specialkentalla = false;
    bool p2specialkentalla = false;
    int specialNopeus = 500;
    double p1special_reload_speed = 0.5;
    double p2special_reload_speed = 0.5;

    int p1kaanto_nopeus = 2;
    int p2kaanto_nopeus = 2;

    int alus1nopeus = 2000;
    int alus2nopeus = 2000;

    Image galaksinKuva = LoadImage( "galaksi" );
    Image asteroidinKuva = LoadImage( "asteroidi" );
    Image[] lisaAseenKuvat = LoadImages( "lisaase1", "lisaase2", "lisaase3", "lisaase4" );
    Image[] alus1IdleKuvat = LoadImages( "alus12", "alus121", "alus122" );
    Image[] alus1KaasuKuvat = LoadImages( "alus12", "alus12_kaasuttaa" );
    Image[] alus2IdleKuvat = LoadImages( "alus22", "alus221", "alus222" );
    Image[] alus2KaasuKuvat = LoadImages( "alus22", "alus22_kaasuttaa" );
    Image[] perusAseKuvat = LoadImages( "plasma", "plasma2" );
    Image[] specialKuvat = LoadImages( "special2", "special22", "special23" );

    Animation alus1_kaasu_tekst;
    Animation alus2_kaasu_tekst;
    Animation alus1_idle_tekst;
    Animation alus2_idle_tekst;

    double resolutionX;
    double resolutionY;

    Timer UpdateTimer;
    double updateInterval = 0.1;

    bool alus1_kaasuttaa = false;
    bool alus2_kaasuttaa = false;

    bool lisaaseita = true;

    int perusAmmusKoko = 4;
    int AlustenHealth = 10;
    double alustenIlmanvastus = 0.999;

    int partikkelit = 50;

    Timer reSpawnTimer1;
    Timer reSpawnTimer2;
    int respawntimer = 3;

    Color p1Color = Color.Red;
    Color p2Color = Color.Blue;


    public override void Begin()
    {
        AloitaPeli();
    }
    void AloitaPeli()
    {
        ClearAll();
        NollaaMuuttujat();

        LuoKentta();
        AsetaOhjaimet();
        LisaaLaskurit();
    }
    void NollaaMuuttujat()
    {
        p1special_reload_speed = 0.5;
        p2special_reload_speed = 0.5;

        p1kaanto_nopeus = 2;
        p2kaanto_nopeus = 2;

        alus1nopeus = 1000;
        alus2nopeus = 1000;

        alus1_kaasuttaa = false;
        alus2_kaasuttaa = false;
        p1specialkentalla = false;
        p2specialkentalla = false;
    }
    void LuoKentta()
    {
        resolutionX = Screen.Width;
        resolutionY = Screen.Height;

        reSpawnTimer1 = new Timer();
        reSpawnTimer1.Interval = respawntimer;
        reSpawnTimer1.Timeout += ReSpawnp1;

        reSpawnTimer2 = new Timer();
        reSpawnTimer2.Interval = respawntimer;
        reSpawnTimer2.Timeout += ReSpawnp2;

        TeeGalaksi();
        TeeAsteroidi( 0, 0, 5, 200 );
        TeeAlukset( true, true );
        UpDate(); //tekee ajopisteet ja tutkii ovatko alukset vielä kentällä
        TeeSpecial(); //tekee special aseet ja lisää kuuntelijat
        TeeHealth();
        TeeAseidenKuvat();
        Level.Background.CreateStars( 3000 );

        TeeReunat();
        Camera.ZoomToLevel();
        MessageDisplay.X = 0;
        MessageDisplay.TextColor = Color.White;

    }
    void TeeGalaksi()
    {
        PhysicsObject galaksi = new PhysicsObject( 700, 700 );
        galaksi.Image = galaksinKuva;
        galaksi.IgnoresExplosions = true;
        galaksi.IgnoresCollisionResponse = true;
        galaksi.IgnoresPhysicsLogics = true;
        galaksi.IgnoresGravity = true;
        galaksi.Tag = "galaksi";
        galaksi.AngularVelocity = -0.1;
        Add( galaksi, -1 );
    }
    void TeeAsteroidi( double x, double y, int lukumaara, double maxkoko )
    {
        for ( int i = 0; i < lukumaara; i++ )
        {

            double koko = RandomGen.NextDouble( maxkoko / 2, maxkoko );
            if ( koko > 30 )
            {
                PhysicsObject asteroidi = new PhysicsObject( koko, koko );
                asteroidi.Shape = Shape.Circle;
                asteroidi.Image = asteroidinKuva;
                asteroidi.Mass = koko * 5;
                asteroidi.IgnoresExplosions = false;
                asteroidi.IgnoresCollisionResponse = false;
                asteroidi.IgnoresPhysicsLogics = false;
                asteroidi.IgnoresGravity = false;
                Vector suunta = Vector.FromLengthAndAngle( RandomGen.NextDouble( 0, koko * 20 ), RandomGen.NextAngle() );
                asteroidi.X = x;// +suunta.X / 10;
                asteroidi.Y = y;// +suunta.Y / 10;
                asteroidi.Hit( suunta );
                asteroidi.Tag = "asteroidi9";
                asteroidi.AngularVelocity = RandomGen.NextDouble( -1, 1 );
                AddCollisionHandler( asteroidi, AsteroidiOsuu );
                Add( asteroidi );
            }
            else if ( lisaaseita && koko > 20 )
            {
                PhysicsObject lisaase = new PhysicsObject( koko, koko );
                lisaase.Color = Color.White;
                lisaase.Tag = "lisaase";
                lisaase.Mass = koko;
                lisaase.Image = lisaAseenKuvat[0];
                lisaase.Animation = new Animation( lisaAseenKuvat );
                lisaase.Animation.FPS = 1;
                lisaase.Animation.Start();
                Vector suunta = Vector.FromLengthAndAngle( RandomGen.NextDouble( 0, koko * 20 ), RandomGen.NextAngle() );
                lisaase.Hit( suunta );
                lisaase.X = x;
                lisaase.Y = y;
                lisaase.AngularVelocity = RandomGen.NextDouble( -3, 3 );
                Add( lisaase );
            }
        }
    }
    void TeeAlukset( bool p1, bool p2 )
    {
        if ( p1 )
        {
            alus1 = LuoAlus( 1, Level.Left + 20.0, 0.0 );
            alus1.Tag = "alus1";
            alus1.Image = alus1IdleKuvat[0];
            alus1.Color = p1Color;
            // AddCollisionHandler(alus1, AlusOsuu);

            alus1_idle_tekst = new Animation( alus1IdleKuvat );
            alus1_idle_tekst.FPS = 1.5;
            alus1.Animation = alus1_idle_tekst;
            alus1.Animation.Start();

            alus1_kaasu_tekst = new Animation( alus1KaasuKuvat );
            alus1_kaasu_tekst.FPS = 10;
            alus1.LinearDamping = alustenIlmanvastus;


        }
        if ( p2 )
        {
            alus2 = LuoAlus( 2, Level.Right - 20.0, 0.0 );
            alus2.Tag = "alus2";
            alus2.Image = alus2IdleKuvat[0];
            alus2.Color = p2Color;
            //      AddCollisionHandler(alus2, AlusOsuu);

            alus2_idle_tekst = new Animation( alus2IdleKuvat );
            alus2_idle_tekst.FPS = 1.5;
            alus2.Animation = alus2_idle_tekst;
            alus2.Animation.Start();


            alus2_kaasu_tekst = new Animation( alus2KaasuKuvat );
            alus2_kaasu_tekst.FPS = 10;

            alus2.Angle = Angle.StraightAngle;
            alus2.LinearDamping = alustenIlmanvastus;
        }
    }
    void TeeReunat()
    {

        vasenReuna = PhysicsObject.CreateStaticObject( 5, resolutionX + 500 );
        vasenReuna.IgnoresPhysicsLogics = true;
        vasenReuna.Color = Color.White;
        vasenReuna.X = -( resolutionX / 2 ) - reunanetaisyysruudusta;
        vasenReuna.Restitution = 1.0;
        vasenReuna.IsVisible = true;
        vasenReuna.Tag = "vasenreuna";
        vasenReuna.IgnoresCollisionResponse = true;
        AddCollisionHandler( vasenReuna, ReunaanOsuu );
        Add( vasenReuna );

        oikeaReuna = PhysicsObject.CreateStaticObject( 5, resolutionX + 500 );
        oikeaReuna.IgnoresPhysicsLogics = true;
        oikeaReuna.Color = Color.White;
        oikeaReuna.X = ( resolutionX / 2 ) + reunanetaisyysruudusta;
        oikeaReuna.Restitution = 1.0;
        oikeaReuna.IsVisible = true;
        oikeaReuna.Tag = "oikeareuna";
        oikeaReuna.IgnoresCollisionResponse = true;
        AddCollisionHandler( oikeaReuna, ReunaanOsuu );
        Add( oikeaReuna );

        ylaReuna = PhysicsObject.CreateStaticObject( resolutionY + 500, 5 );
        ylaReuna.IgnoresPhysicsLogics = true;
        ylaReuna.Color = Color.White;
        ylaReuna.Y = ( resolutionY / 2 ) + reunanetaisyysruudusta;
        ylaReuna.Restitution = 0.0;
        ylaReuna.IsVisible = true;
        ylaReuna.Tag = "ylareuna";
        ylaReuna.IgnoresCollisionResponse = true;
        AddCollisionHandler( ylaReuna, ReunaanOsuu );
        Add( ylaReuna );

        alaReuna = PhysicsObject.CreateStaticObject( resolutionY + 500, 5 );
        alaReuna.IgnoresPhysicsLogics = true;
        alaReuna.Color = Color.White;
        alaReuna.Y = -( resolutionY / 2 ) - reunanetaisyysruudusta;
        alaReuna.Restitution = 0.0;
        alaReuna.IsVisible = true;
        alaReuna.Tag = "alareuna";
        alaReuna.IgnoresCollisionResponse = true;
        AddCollisionHandler( alaReuna, ReunaanOsuu );
        Add( alaReuna );
    }
    void TeeAseidenKuvat()
    {
        Widget alus1PerusAse = new Widget( 40, 40 );
        alus1PerusAse.X = Screen.Left + 50;
        alus1PerusAse.Y = Screen.Top - 50;
        alus1PerusAse.Image = perusAseKuvat[0];
        alus1PerusAse.Animation = new Animation( perusAseKuvat );
        alus1PerusAse.Animation.FPS = 15;
        alus1PerusAse.Animation.Start();

        Add( alus1PerusAse );

        Widget alus2PerusAse = new Widget( 40, 40 );
        alus2PerusAse.X = Screen.Right - 50;
        alus2PerusAse.Y = Screen.Top - 50;
        alus2PerusAse.Image = perusAseKuvat[0];
        alus2PerusAse.Animation = new Animation( perusAseKuvat );
        alus2PerusAse.Animation.FPS = 15;
        alus2PerusAse.Animation.Start();
        Add( alus2PerusAse );

        Widget alus1SpecialAse = new Widget( 40, 40 );
        alus1SpecialAse.X = Screen.Left + 100;
        alus1SpecialAse.Y = Screen.Top - 50;
        alus1SpecialAse.Image = specialKuvat[0];
        alus1SpecialAse.Animation = new Animation( specialKuvat );
        alus1SpecialAse.Animation.FPS = 4;
        alus1SpecialAse.Animation.Start();
        Add( alus1SpecialAse );

        Widget alus2SpecialAse = new Widget( 40, 40 );
        alus2SpecialAse.X  = Screen.Right - 100;
        alus2SpecialAse.Y = Screen.Top - 50;
        alus2SpecialAse.Image = specialKuvat[0];
        alus2SpecialAse.Animation = new Animation( specialKuvat );
        alus2SpecialAse.Animation.FPS = 4;
        alus2SpecialAse.Animation.Start();

        Add( alus2SpecialAse );
    }

    PhysicsObject LuoAlus( int kumpi, double x, double y )
    {
        PhysicsObject alus = new PhysicsObject( 60.0, 45.0 );
        alus.Shape = Shape.Rectangle;
        alus.X = x;
        alus.Y = y;
        alus.Mass = 10;
        alus.Restitution = 1.0;
        alus.CanRotate = true;
        alus.IgnoresCollisionResponse = false;
        AddCollisionHandler( alus, AlusOsuu );
        Add( alus );
        return alus;
    }
    void LisaaLaskurit()
    {
        p1Pisteet = LuoPisteLaskuri( Screen.Left + 75.0, Screen.Top - 250.0, p1Color );
        p2Pisteet = LuoPisteLaskuri( Screen.Right - 75.0, Screen.Top - 250.0, p2Color );
    }
    IntMeter LuoPisteLaskuri( double x, double y, Color vari )
    {
        IntMeter laskuri = new IntMeter( 0 );
        laskuri.MaxValue = AlustenHealth;
        Label naytto = new Label();
        naytto.BindTo( laskuri );
        naytto.X = x;
        naytto.Y = y;
        naytto.TextColor = vari;
        Add( naytto );
        return laskuri;
    }
    void AsetaOhjaimet()
    {

        Keyboard.Listen( Key.A, ButtonState.Down, KaannaVasen, "käännä alusta vasemmalle", alus1, 1 );
        Keyboard.Listen( Key.A, ButtonState.Released, PysaytaPyoriminen, null, alus1, 1 );
        Keyboard.Listen( Key.D, ButtonState.Down, KaannaOikea, "käännä alusta oikealle", alus1, 1 );
        Keyboard.Listen( Key.D, ButtonState.Released, PysaytaPyoriminen, null, alus1, 1 );
        Keyboard.Listen( Key.W, ButtonState.Down, Kaasua, "kaasu", alus1, 1 );
        Keyboard.Listen( Key.W, ButtonState.Released, Eikaasua, null, alus1, 1 );
        Keyboard.Listen( Key.Tab, ButtonState.Pressed, Ammu, null, alus1, 1 );

        Keyboard.Listen( Key.Left, ButtonState.Down, KaannaVasen, "käännä alusta vasemmalle", alus2, 1 );
        Keyboard.Listen( Key.Left, ButtonState.Released, PysaytaPyoriminen, null, alus2, 1 );
        Keyboard.Listen( Key.Right, ButtonState.Down, KaannaOikea, "käännä alusta oikealle", alus2, 1 );
        Keyboard.Listen( Key.Right, ButtonState.Released, PysaytaPyoriminen, null, alus2, 1 );
        Keyboard.Listen( Key.Up, ButtonState.Down, Kaasua, "kaasu", alus2, 1 );
        Keyboard.Listen( Key.Up, ButtonState.Released, Eikaasua, null, alus2, 1 );
        Keyboard.Listen( Key.RightShift, ButtonState.Pressed, Ammu, null, alus2, 1 );

        Keyboard.Listen( Key.F1, ButtonState.Pressed, ShowControlHelp, "Näytä ohjeet" );
        Keyboard.Listen( Key.Escape, ButtonState.Pressed, Exit, "Poistu" );
        Keyboard.Listen( Key.F2, ButtonState.Pressed, AloitaPeli, "uusi peli" );
    }
    void KaannaVasen( PhysicsObject alus, int nopeus )
    {
        if ( alus.Tag.ToString() == "alus1" )
        {
            alus.AngularVelocity = p1kaanto_nopeus;
        }
        else if ( alus.Tag.ToString() == "alus2" )
        {
            alus.AngularVelocity = p2kaanto_nopeus;
        }
    }
    void KaannaOikea( PhysicsObject alus, int nopeus )
    {
        if ( alus.Tag.ToString() == "alus1" )
        {
            alus.AngularVelocity = -p1kaanto_nopeus;
        }
        else if ( alus.Tag.ToString() == "alus2" )
        {
            alus.AngularVelocity = -p2kaanto_nopeus;
        }
    }
    void PysaytaPyoriminen( PhysicsObject alus, int nopeus )
    {
        alus.AngularVelocity = 0;
    }
    void Kaasua( PhysicsObject alus, int nopeus )
    {
        Angle aluksenKulma = alus.Angle;
        Vector impulssi;
        if ( alus.Tag.ToString() == "alus1" )
        {
            impulssi = Vector.FromLengthAndAngle( alus1nopeus, aluksenKulma );
        }
        else
        {
            impulssi = Vector.FromLengthAndAngle( alus2nopeus, aluksenKulma );
        }
        double aluksenAste = aluksenKulma.Degrees;
        alus.Push( impulssi );
        alus.Animation.Resume();
        if ( alus.Tag.ToString() == "alus1" )
        {
            alus1_kaasuttaa = true;
            alus1.Animation = alus1_kaasu_tekst;

        }
        if ( alus.Tag.ToString() == "alus2" )
        {
            alus2_kaasuttaa = true;
            alus2.Animation = alus2_kaasu_tekst;
        }

    }
    void Eikaasua( PhysicsObject alus, int nopeus )
    {
        alus.Animation.Stop();
        if ( alus.Tag.ToString() == "alus1" )
        {
            alus1_kaasuttaa = false;
            alus1.Animation = alus1_idle_tekst;

        }
        if ( alus.Tag.ToString() == "alus2" )
        {
            alus2_kaasuttaa = false;
            alus2.Animation = alus2_idle_tekst;
        }
    }
    void Ammu( PhysicsObject alus, int nopeus )
    {
        PhysicsObject ammus = new PhysicsObject( perusAmmusKoko, perusAmmusKoko );
        ammus.Shape = Shape.Circle;
        ammus.Color = Color.YellowGreen;
        ammus.X = alus.X;
        ammus.Y = alus.Y;
        ammus.Mass = 5;
        ammus.IgnoresCollisionResponse = true;
        ammus.IgnoresExplosions = true;
        TimeSpan elinaika = new TimeSpan( 15000000 );
        ammus.MaximumLifetime = elinaika;
        ammus.Tag = alus.Tag + "ammus";
        AddCollisionHandler( ammus, AmmusOsuu );
        Add( ammus );
        Angle aluksenKulma = alus.Angle;
        Vector impulssi = Vector.FromLengthAndAngle( 2500, aluksenKulma );
        ammus.Hit( impulssi );
    }
    void AmmusOsuu( PhysicsObject ammus, PhysicsObject kohde )
    {
        if ( kohde.Tag.ToString() != "galaksi" )
        {
            string ampuja = ammus.Tag.ToString();
            string uhri = kohde.Tag.ToString();


            if ( ampuja[4] != uhri[4] && kohde.Tag.ToString() != "ajopiste" )
            {
                string special = ammus.Tag.ToString();
                if ( special[5] == 's' ) //jos special
                {
                    if ( special[4] == '2' )
                    {
                        Rajaytap2Special( ammus );
                    }
                    else if ( special[4] == '1' )
                    {
                        Rajaytap1Special( ammus );
                    }
                }
                else
                {
                    Explosion rajahdys;
                    rajahdys = new Explosion( 40 );
                    rajahdys.Position = ammus.Position;
                    Add( rajahdys );
                }
                if ( uhri[1] == 's' )
                {
                    double asteroidinenergia = char.GetNumericValue( uhri[9] );
                    if ( special[5] == 's' )
                    {
                        asteroidinenergia -= (int)( ammus.Width / 3 );
                    }
                    else
                    {
                        asteroidinenergia--;
                    }
                    if ( asteroidinenergia <= 0 )
                    {
                        TeeAsteroidi( kohde.X, kohde.Y, 3, ( kohde.Width / 2 ) );
                        kohde.Destroy();
                    }
                    else
                    {
                        string uhrinuusitag = "asteroidi";
                        string uusienergia = asteroidinenergia.ToString();
                        uhrinuusitag = uhrinuusitag + uusienergia[0];
                        kohde.Tag = uhrinuusitag;
                    }

                }

                if ( kohde.Tag.ToString() == "alus2" )
                {
                    p2healthmittari.Value -= (int)( ammus.Width / 3 );
                }
                else if ( kohde.Tag.ToString() == "alus1" )
                {
                    p1healthmittari.Value -= (int)( ammus.Width / 3 );
                }
                ammus.Destroy();
            }
        }
    }
    void AlusOsuu( PhysicsObject alus, PhysicsObject kohde )
    {
        if ( kohde.Tag.ToString().Length > 8 )
        {
            string kohdestr = kohde.Tag.ToString();
            if ( alus.Tag.ToString() == "alus2" && kohdestr[8] == 'i' )
            {
                p2healthmittari.Value -= 1;
            }
            else if ( alus.Tag.ToString() == "alus1" && kohdestr[8] == 'i' )
            {
                p1healthmittari.Value -= 1;
            }
        }
        if ( kohde.Tag.ToString() == "lisaase" )
        {
            int mikaase = RandomGen.NextInt( 5 );
            if ( mikaase == 0 )
            {
                if ( alus.Tag.ToString() == "alus1" )
                {
                    p1special_reload_speed += 0.5;
                    MessageDisplay.TextColor = p1Color;
                    MessageDisplay.Add( "Pelaaja 1 special latausnopeus +" );
                }
                if ( alus.Tag.ToString() == "alus2" )
                {
                    p2special_reload_speed += 0.5;
                    MessageDisplay.TextColor = p2Color;
                    MessageDisplay.Add( "Pelaaja 2 special latausnopeus +" );
                }
            }
            if ( mikaase == 1 )
            {
                if ( alus.Tag.ToString() == "alus1" )
                {
                    p1healthmittari.Value += AlustenHealth / 2;
                    MessageDisplay.TextColor = p1Color;
                    MessageDisplay.Add( "Pelaaja 1 health +" );
                }
                if ( alus.Tag.ToString() == "alus2" )
                {
                    p2healthmittari.Value += AlustenHealth / 2;
                    MessageDisplay.TextColor = p2Color;
                    MessageDisplay.Add( "Pelaaja 2 health +" );
                }
            }
            if ( mikaase == 2 )
            {
                if ( alus.Tag.ToString() == "alus1" )
                {
                    alus1nopeus += 1000;
                    MessageDisplay.TextColor = p1Color;
                    MessageDisplay.Add( "Pelaaja 1 nopeus +" );
                }
                if ( alus.Tag.ToString() == "alus2" )
                {
                    alus2nopeus += 1000;
                    MessageDisplay.TextColor = p2Color;
                    MessageDisplay.Add( "Pelaaja 2 nopeus +" );
                }
            }
            if ( mikaase == 3 )
            {
                if ( alus.Tag.ToString() == "alus1" )
                {
                    p1kaanto_nopeus += 1;
                    MessageDisplay.TextColor = p1Color;
                    MessageDisplay.Add( "Pelaaja 1 kääntönopeus +" );
                }
                if ( alus.Tag.ToString() == "alus2" )
                {
                    p2kaanto_nopeus += 1;
                    MessageDisplay.TextColor = p2Color;
                    MessageDisplay.Add( "Pelaaja 2 kääntönopeus +" );
                }
            }
            kohde.Destroy();
        }
    }
    void UpDate()
    {
        UpdateTimer = new Timer();                     // luodaan uusi ajastin, nimeltä aikaLaskuri
        UpdateTimer.Interval = updateInterval;                      // ajastukseksi 5 sekuntia
        UpdateTimer.Timeout += Paivitys;  //   // asetetaan tapahtuma, kun aikaLaskuri kun 5 sekuntia on kulunut.
        UpdateTimer.Start();                           // käynnistetään aikaLaskuri     
    }
    private void Paivitys()
    {
        //ovatko alukset kentällä
        if ( alus1.X < ( vasenReuna.X - 50 ) )
        {
            alus1.X = oikeaReuna.X - siirtymaLaidassa;
        }
        if ( alus2.X < ( vasenReuna.X - 50 ) )
        {
            alus2.X = oikeaReuna.X - siirtymaLaidassa;
        }
        if ( alus1.X > ( oikeaReuna.X + 50 ) )
        {
            alus1.X = vasenReuna.X + siirtymaLaidassa;
        }
        if ( alus2.X > ( oikeaReuna.X + 50 ) )
        {
            alus2.X = vasenReuna.X + siirtymaLaidassa;
        }
        if ( alus1.Y > ( ylaReuna.Y + 50 ) )
        {
            alus1.Y = alaReuna.Y + siirtymaLaidassa;
        }
        if ( alus2.Y > ( ylaReuna.Y + 50 ) )
        {
            alus2.Y = alaReuna.Y + siirtymaLaidassa;
        }
        if ( alus1.Y < ( alaReuna.Y - 50 ) )
        {
            alus1.Y = ylaReuna.Y - siirtymaLaidassa;
        }
        if ( alus2.Y < ( alaReuna.Y - 50 ) )
        {
            alus1.Y = ylaReuna.Y - siirtymaLaidassa;
        }


        if ( alus1_kaasuttaa ) //ajopisteen teko
        {
            PhysicsObject piste = teeAjopiste( alus1 );
            Add( piste );
        }
        if ( alus2_kaasuttaa ) //ajopisteen teko
        {
            PhysicsObject piste = teeAjopiste( alus2 );
            Add( piste );
        }
    }
    PhysicsObject teeAjopiste( PhysicsObject alus )
    {
        PhysicsObject piste = new PhysicsObject( 2, 2 );
        piste.Shape = Shape.Circle;
        piste.Color = Color.Yellow;
        piste.IgnoresCollisionResponse = true;
        piste.Tag = "ajopiste";
        piste.X = alus.X;
        piste.Y = alus.Y;
        TimeSpan elinaika = new TimeSpan( 20000000 );
        piste.MaximumLifetime = elinaika;
        Angle aluksenKulma = alus.Angle + Angle.StraightAngle;
        Vector impulssi = Vector.FromLengthAndAngle( 50, aluksenKulma );
        piste.Hit( impulssi );
        return piste;
    }
    void ReunaanOsuu( PhysicsObject reuna, PhysicsObject osuja )
    {
        string asteroidiko = osuja.Tag.ToString();
        if ( asteroidiko[1] != 's' )
        {
            if ( reuna.Tag.ToString() == "ylareuna" )
            {
                osuja.Y = alaReuna.Y + siirtymaLaidassa;
            }

            if ( reuna.Tag.ToString() == "alareuna" )
            {
                osuja.Y = ylaReuna.Y - siirtymaLaidassa;
            }
            if ( reuna.Tag.ToString() == "vasenreuna" )
            {
                osuja.X = ( oikeaReuna.X - siirtymaLaidassa );
            }

            if ( reuna.Tag.ToString() == "oikeareuna" )
            {
                osuja.X = ( vasenReuna.X + siirtymaLaidassa );
            }
        }
    }
    void TeeHealth()
    {
        BarGauge p1health = new BarGauge( 40, 100 );
        p1healthmittari = new DoubleMeter( AlustenHealth );
        p1healthmittari.MaxValue = AlustenHealth;
        p1healthmittari.MinValue = 0;
        p1healthmittari.LowerLimit += Voitto;
        p1health.BindTo( p1healthmittari );
        p1health.BarColor = p1Color;
        p1health.X = Screen.Left + 50;
        p1health.Y = Screen.Top - 150;
        Add( p1health );

        BarGauge p2health = new BarGauge( 40, 100 );
        p2healthmittari = new DoubleMeter( AlustenHealth );
        p2healthmittari.MaxValue = AlustenHealth;
        p2healthmittari.MinValue = 0;
        p2healthmittari.LowerLimit += Voitto;
        p2health.BindTo( p2healthmittari );
        p2health.BarColor = p2Color;
        p2health.X = Screen.Right - 50;
        p2health.Y = Screen.Top - 150;
        Add( p2health );
    }
    void TeeSpecial()
    {
        LisaaSpecialOhjaimet();
        LisaaSpecialMittarit();
    }
    void LisaaSpecialOhjaimet()
    {
        Keyboard.Listen( Key.LeftShift, ButtonState.Down, LataaSpecial, "Special lataus", alus1, 1 );
        Keyboard.Listen( Key.LeftShift, ButtonState.Released, LaukaiseSpecial, "laukaise special", alus1, 1 );
        Keyboard.Listen( Key.RightControl, ButtonState.Down, LataaSpecial, "Special lataus", alus2, 1 );
        Keyboard.Listen( Key.RightControl, ButtonState.Released, LaukaiseSpecial, "laukaise special", alus2, 1 );
    }
    void LisaaSpecialMittarit()
    {
        p1specialTeho = new DoubleMeter( perusAmmusKoko + 1 );
        p1specialTeho.MaxValue = 100;

        p2specialTeho = new DoubleMeter( perusAmmusKoko + 1 );
        p2specialTeho.MaxValue = 100;

        BarGauge p1special = new BarGauge( 40, 100 );
        p1special.BarColor = p1Color;
        p1special.BindTo( p1specialTeho );
        p1special.X = Screen.Left + 100;
        p1special.Y = Screen.Top - 150;
        Add( p1special );

        BarGauge p2special = new BarGauge( 40, 100 );
        p2special.BarColor = p2Color;
        p2special.BindTo( p2specialTeho );
        p2special.X = Screen.Right - 100;
        p2special.Y = Screen.Top - 150;
        Add( p2special );
    }
    void LataaSpecial( PhysicsObject alus, int nopeus )
    {
        if ( alus.Tag.ToString() == "alus1" && !p1specialkentalla )
        {
            p1specialTeho.Value += p1special_reload_speed;
        }
        if ( alus.Tag.ToString() == "alus2" && !p2specialkentalla )
        {
            p2specialTeho.Value += p2special_reload_speed;
        }

    }
    void LaukaiseSpecial( PhysicsObject alus, int nopeus )
    {
        if ( alus.Tag.ToString() == "alus1" && !p1specialkentalla )
        {
            PhysicsObject ammus = new PhysicsObject( ( p1specialTeho / 3 ), ( p1specialTeho / 3 ) );
            ammus.Shape = Shape.Circle;
            ammus.Color = p1Color;
            ammus.X = alus.X;
            ammus.Y = alus.Y;
            ammus.IgnoresCollisionResponse = true;
            ammus.Tag = alus.Tag + "special";
            AddCollisionHandler( ammus, AmmusOsuu );
            ammus.Image = specialKuvat[0];
            ammus.CanRotate = true;
            ammus.AngularVelocity = 3;
            Add( ammus );
            Angle aluksenKulma = alus.Angle;
            Vector impulssi = Vector.FromLengthAndAngle( specialNopeus, aluksenKulma );
            ammus.Hit( impulssi );
            p1specialkentalla = true;
            Timer.SingleShot( specialLifeTime, delegate { Rajaytap1Special( ammus ); } );
            p1specialTeho.Value = 1;
        }
        if ( alus.Tag.ToString() == "alus2" && !p2specialkentalla )
        {
            PhysicsObject ammus = new PhysicsObject( ( p2specialTeho / 2 ), ( p2specialTeho / 2 ) );
            ammus.Shape = Shape.Circle;
            ammus.Color = p2Color;
            ammus.X = alus.X;
            ammus.Y = alus.Y;
            ammus.IgnoresCollisionResponse = true;
            TimeSpan elinaika = TimeSpan.FromSeconds( specialLifeTime );
            ammus.MaximumLifetime = elinaika;
            ammus.Tag = alus.Tag + "special";
            AddCollisionHandler( ammus, AmmusOsuu );
            ammus.Image = specialKuvat[0];
            ammus.CanRotate = true;
            ammus.AngularVelocity = 3;
            Add( ammus );
            Angle aluksenKulma = alus.Angle;
            Vector impulssi = Vector.FromLengthAndAngle( specialNopeus, aluksenKulma );
            ammus.Hit( impulssi );
            p2specialkentalla = true;
            Timer.SingleShot( specialLifeTime, delegate { Rajaytap2Special( ammus ); } );
            p2specialTeho.Value = 1;
        }
    }
    private void Rajaytap1Special( PhysicsObject ammus )
    {
        Explosion jysays = new Explosion( ammus.Width * 3 );
        jysays.Position = ammus.Position;
        jysays.Force = 10;
        Add( jysays );
        ammus.Destroy();
        p1specialkentalla = false;
    }
    private void Rajaytap2Special( PhysicsObject ammus )
    {
        Explosion jysays = new Explosion( ammus.Width * 3 );
        jysays.Position = ammus.Position;
        jysays.Force = 10;
        Add( jysays );
        ammus.Destroy();
        p2specialkentalla = false;
    }
    void Voitto( Double laskuri )
    {
        if ( p2healthmittari <= 0 )
        {
            MessageDisplay.TextColor = p1Color;
            MessageDisplay.Add( "Pelaaja 1 voitti erän!" );
            p1Pisteet.Value += 1;
            TuhoaAlus( alus2 );
            reSpawnTimer2.Start( 1 );
        }
        if ( p1healthmittari <= 0 )
        {
            MessageDisplay.TextColor = p2Color;
            MessageDisplay.Add( "Pelaaja 2 voitti erän!" );
            p2Pisteet.Value += 1;
            TuhoaAlus( alus1 );
            reSpawnTimer1.Start( 1 );
        }
    }
    void AsteroidiOsuu( PhysicsObject asteroidi, PhysicsObject kohde )
    {
        if ( kohde.Tag.ToString() == "vasenreuna" )
        {
            asteroidi.X = oikeaReuna.X - asteroidi.Width;
        }
        if ( kohde.Tag.ToString() == "oikeareuna" )
        {
            asteroidi.X = vasenReuna.X + asteroidi.Width;
        }
        if ( kohde.Tag.ToString() == "ylareuna" )
        {
            asteroidi.Y = alaReuna.Y + asteroidi.Width;
        }
        if ( kohde.Tag.ToString() == "alareuna" )
        {
            asteroidi.Y = ylaReuna.Y - asteroidi.Width;
        }
    }
    void TuhoaAlus( PhysicsObject alus )
    {
        Explosion jysy = new Explosion( 250 );
        jysy.X = alus.X;
        jysy.Y = alus.Y;
        Add( jysy );
        for ( int i = 0; i < partikkelit; i++ )
        {
            PhysicsObject jama = new PhysicsObject( RandomGen.NextInt( 1, 20 ), RandomGen.NextInt( 1, 10 ) );
            bool nelioko = RandomGen.NextBool();
            if ( nelioko )
            {
                jama.Shape = Shape.Rectangle;
            }
            else
            {
                jama.Shape = Shape.Triangle;
            }
            nelioko = RandomGen.NextBool();
            if ( nelioko )
            {
                jama.Color = RandomGen.NextColor( Color.Red, Color.Yellow );
            }
            else
            {
                jama.Color = alus.Color;
            }
            jama.X = alus.X;
            jama.Y = alus.Y;
            Vector maiskeenlento = Vector.FromLengthAndAngle( RandomGen.NextDouble( 0, 100 ), RandomGen.NextAngle() );
            TimeSpan eloaika = TimeSpan.FromSeconds( 1 );
            jama.MaximumLifetime = eloaika;
            jama.Tag = "jamaa";
            jama.IgnoresCollisionResponse = true;
            jama.IgnoresExplosions = true;
            jama.IgnoresGravity = true;
            jama.IgnoresPhysicsLogics = true;
            jama.KineticFriction = 0.5;
            jama.LinearDamping = 0.99;
            jama.Hit( maiskeenlento );
            Add( jama );
        }
        alus.Stop();
        Remove( alus );
    }
    private void ReSpawnp1()
    {
        alus1.X = ( Level.Left + 20.0 );
        alus1.Y = 0.0;
        p1healthmittari.Value = AlustenHealth;
        Add( alus1 );
    }
    private void ReSpawnp2()
    {

        alus2.X = ( Level.Right - 20.0 );
        alus2.Y = 0.0;
        p2healthmittari.Value = AlustenHealth;
        Add( alus2 );
    }
}
