;
; Installs Jypeli.
;

Name "The Jypeli Game Programming Library"

OutFile "Jypeli_setup.exe"

InstallDir $PROGRAMFILES\Jypeli

InstallDirRegKey HKLM "Software\Jypeli" "Install_Dir"

RequestExecutionLevel admin

;--------------------------------

; Pages

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

Section "Jypeli"
  SectionIn RO
  
  SetOutPath "$INSTDIR\lib\x86"
  File "..\Compiled\x86\Jypeli\Jypeli4.dll"
  File "..\Compiled\x86\Jypeli\Jypeli4.xml"

  SetOutPath "$INSTDIR\lib\Windows Phone"
  File "..\Compiled\Windows Phone\Jypeli\Jypeli4.dll"
  File "..\Compiled\Windows Phone\Jypeli\Jypeli4.xml"
  File "..\Compiled\Windows Phone\Jypeli\Jypeli.WP7.Camera.dll"
  File "..\Compiled\Windows Phone\Jypeli\Jypeli.WP7.Camera.xml"
  File "..\Compiled\Windows Phone\Jypeli\Jypeli.WP7.GPS.dll"
  File "..\Compiled\Windows Phone\Jypeli\Jypeli.WP7.GPS.xml"

  SetOutPath "$INSTDIR\lib\ContentExtensions"
  File "..\Compiled\ContentExtensions\TextFileContentExtension.dll"
  
  WriteRegStr HKLM "SOFTWARE\Jypeli" "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Jypeli" "DisplayName" "Jypeli"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Jypeli" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Jypeli" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Jypeli" "NoRepair" 1

  WriteUninstaller "uninstall.exe"
SectionEnd

Section "Project templates"
  ReadEnvStr $0 VS100COMNTOOLS
  
  IfFileExists "$0..\IDE\VCSExpress\*.*" 0 VsExpressForPhone
    StrCpy $1 "$0..\IDE\VCSExpress\ProjectTemplates\1033"
	SetOutPath $1
    File "..\projektimallit\*.zip"
	Exec '"$0..\IDE\vcsexpress.exe" /installvstemplates'
	Goto VsExpressForPhone
  
  VsExpressForPhone:
	ReadRegStr $5 HKLM "Software\Microsoft\VPDExpress\10.0" "InstallDir"
	StrCmp $5 "" VSPro 0	
    CreateDirectory "$5\VPDExpress\ProjectTemplates\Jypeli\1033"
	StrCpy $1 "$5\VPDExpress\ProjectTemplates\Jypeli\1033"
	SetOutPath $1
    File "..\projektimallit\*.zip"
	Exec '"$5\VPDExpress.exe" /installvstemplates'    	
	Goto VSPro
	
  VSPro:
	IfFileExists "$0..\IDE\devenv.exe" 0 Done
      StrCpy $1 "$0..\IDE\ProjectTemplates\CSharp\Jypeli"
      CreateDirectory $1
      SetOutPath $1
      File "..\projektimallit\*.zip"
      Exec '"$0..\IDE\devenv" /installvstemplates'

  Done:
SectionEnd

Section "Example Games"
  SetOutPath $INSTDIR\examples
  File /r "..\Compiled\x86\Autopeli"
  File /r "..\Compiled\x86\FallDown"
  File /r "..\Compiled\x86\Marswagen"
  File /r "..\Compiled\x86\Muistipeli"
  File /r "..\Compiled\x86\Piano"
  File /r "..\Compiled\x86\ViimeinenSysteemi"
SectionEnd

Section "Start Menu Shortcuts"
  CreateDirectory "$SMPROGRAMS\Jypeli"
  CreateShortCut "$SMPROGRAMS\Jypeli\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateDirectory "$SMPROGRAMS\Jypeli\Example Games"
  CreateShortCut "$SMPROGRAMS\Jypeli\Example Games\Autopeli.lnk" "$INSTDIR\examples\Autopeli\Autopeli.exe" "" "$INSTDIR\examples\Autopeli\Autopeli.exe" 0
  CreateShortCut "$SMPROGRAMS\Jypeli\Example Games\FallDown.lnk" "$INSTDIR\examples\FallDown\FallDown.exe" "" "$INSTDIR\examples\FallDown\FallDown.exe" 0
  CreateShortCut "$SMPROGRAMS\Jypeli\Example Games\Marswagen.lnk" "$INSTDIR\examples\Marswagen\Marswagen.exe" "" "$INSTDIR\examples\Marswagen\Marswagen.exe" 0
  CreateShortCut "$SMPROGRAMS\Jypeli\Example Games\Muistipeli.lnk" "$INSTDIR\examples\Muistipeli\Muistipeli.exe" "" "$INSTDIR\examples\Muistipeli\Muistipeli.exe" 0
  CreateShortCut "$SMPROGRAMS\Jypeli\Example Games\Piano.lnk" "$INSTDIR\examples\Piano\Piano.exe" "" "$INSTDIR\examples\Piano\Piano.exe" 0
  CreateShortCut "$SMPROGRAMS\Jypeli\Example Games\ViimeinenSysteemi.lnk" "$INSTDIR\examples\ViimeinenSysteemi\ViimeinenSysteemi.exe" "" "$INSTDIR\examples\ViimeinenSysteemi\ViimeinenSysteemi.exe" 0
SectionEnd

;--------------------------------


Section "Uninstall"
  
  ; Register values
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Jypeli"
  DeleteRegKey HKLM "SOFTWARE\Jypeli"

  ; Installation dir
  Delete $INSTDIR\uninstall.exe
  RMDir /r /REBOOTOK $INSTDIR\examples
  RMDir /r /REBOOTOK $INSTDIR\lib
  RMDir "$INSTDIR"

  ; Project templates
  ReadEnvStr $0 VS100COMNTOOLS
  StrCpy $1 "$0..\IDE\ProjectTemplates\CSharp\Jypeli"
  Delete "$1\*.zip"
  RMDir "$1"
  
  ; Shortcuts
  RMDir /r "$SMPROGRAMS\Jypeli\Example Games"
  Delete "$SMPROGRAMS\Jypeli\*.*"
  RMDir "$SMPROGRAMS\Jypeli"

SectionEnd
