﻿using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Effects;
using Jypeli.Widgets;

public class Peli : PhysicsGame
{
    AxleJoint aurinkoJoint, maaJoint, kuuJoint;
    GameObject ajPaikka, mjPaikka, kjPaikka;

    public override void Begin()
    {
        Level.Width = 2000;
        Level.Height = 2000;
        Level.Background.Image = Image.CreateStarSky( 1000, 1000, 1000 );
        Level.Background.FitToLevel();

        PhysicsObject aurinko = PhysicsObject.CreateStaticObject( 100, 100 );
        aurinko.Color = Color.LightYellow;
        aurinko.Shape = Shape.Circle;
        aurinko.Mass = 100;
        //Add( aurinko );

        PhysicsObject maa = new PhysicsObject( 20, 20 );
        maa.Color = Color.DarkBlue;
        maa.Shape = Shape.Circle;
        maa.X = 300;
        maa.Mass = 10;
        //Add( maa );

        PhysicsObject kuu = new PhysicsObject( 6, 6 );
        kuu.Color = Color.DarkGray;
        kuu.Shape = Shape.Circle;
        kuu.X = maa.X;
        kuu.Y = maa.Y + 30;
        kuu.Mass = 3;
        //Add( kuu );

        aurinkoJoint = new AxleJoint( aurinko );
        aurinkoJoint.Softness = 0.01;
        Add( aurinkoJoint );

        maaJoint = new AxleJoint( maa, Vector.Zero );
        maaJoint.Softness = 0.5;
        Add( maaJoint );

        kuuJoint = new AxleJoint( kuu, maa );
        kuuJoint.Softness = 0.7;
        Add( kuuJoint );

        ajPaikka = new GameObject( 3, 3 ) { Color = Color.Red };
        Add( ajPaikka );
        mjPaikka = new GameObject( 3, 3 ) { Color = Color.Yellow };
        Add( mjPaikka );
        kjPaikka = new GameObject( 3, 3 ) { Color = Color.Green };
        Add( kjPaikka );

        kuu.Hit( 50 * Vector.UnitX );
        maa.Hit( -200 * Vector.UnitY );

        PhysicsObject kuutio = new PhysicsObject( 50, 50 );
        kuutio.Color = Color.Gray;
        kuutio.Mass = 10;
        kuutio.Y = -300;
        Add( kuutio );

        Mouse.ListenMovement( 0, LiikutaKappaletta, null, kuutio );
    }

    void LiikutaKappaletta( AnalogState tila, PhysicsObject kuutio )
    {
        kuutio.Push( kuutio.Mass * tila.MouseMovement * 10 );
    }

    protected override void Update( Time time )
    {
        if ( ajPaikka != null )
        {
            ajPaikka.Position = aurinkoJoint.AxlePoint;
            mjPaikka.Position = maaJoint.AxlePoint;
            kjPaikka.Position = kuuJoint.AxlePoint;
        }

        base.Update( time );
    }
}
