﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Effects;
using Jypeli.Widgets;
using Jypeli.WP7;

public class Peli : Game
{
    public override void Begin()
    {
        Phone.DisplayOrientation = DisplayOrientation.Landscape;
        Phone.DisplayResolution = DisplayResolution.Large;
        MessageDisplay.RealTime = true;

        GameObject gobj = new GameObject( Screen.Width / 2, 2 * Screen.Height / 3 );
        gobj.Color = Color.Red;
        Add( gobj );

        Widget w = new Widget( 2 * Screen.Width / 3, 1 * Screen.Height / 3 );
        w.Color = Color.Blue;
        Add( w );

        Mouse.ListenOn( gobj, MouseButton.Left, ButtonState.Down, MessageDisplay.Add, null, "Game object clicked" );
        Mouse.ListenOn( w, MouseButton.Left, ButtonState.Down, MessageDisplay.Add, null, "Widget clicked" );
        Mouse.Listen( MouseButton.Left, ButtonState.Down, MessageDisplay.Add, null, "Background clicked" );

        Mouse.IsCursorVisible = true;

        TouchPanel.ListenOn( gobj, ButtonState.Pressed, ShowText, null, "Game object clicked" );
        TouchPanel.ListenOn( w, ButtonState.Pressed, ShowText, null, "Widget clicked" );
        TouchPanel.Listen( ButtonState.Pressed, ShowText, null, "Background clicked" );
    }

    public void ShowText( Touch touch, string text )
    {
        MessageDisplay.Add( text );
    }
}
