﻿using Jypeli;
using Jypeli.Controls;
using Jypeli.Assets;

namespace ComposingTest
{
    public class Peli : PhysicsGame
    {
        PhysicsObject composed;

        public override void Begin()
        {
            Level.CreateBorders();
            Gravity = new Vector( 0, -150 );
            Camera.ZoomToLevel();

            CreateComposedObject();

            Keyboard.Listen( Key.F1, ButtonState.Pressed, ShowControlHelp, "Näytä ohjeet" );
            Keyboard.Listen( Key.Escape, ButtonState.Pressed, Exit, "Poistu pelistä" );
            Keyboard.Listen( Key.Space, ButtonState.Pressed, Enlarge, "Kasvata oliota" );
        }

        void Enlarge()
        {
            //composed.Size = composed.Size + new Vector( 1, 1 );
            composed.Size *= 1.1;
        }

        void CreateComposedObject()
        {
            composed = new PhysicsObject( 100, 100 );
            composed.Mass = 100;
            //composed = new GameObject( new Vector( 1, 1 ) );
            composed.Shape = Shape.Rectangle;
            //composed.Angle = Angle.FromDegrees( 30 );
            composed.Color = Color.Green;

            GameObject leftSubObject = new GameObject( 0.5, 0.5 );
            leftSubObject.Color = Color.Red;
            leftSubObject.Angle = Angle.FromDegrees( 45 );
            leftSubObject.Position = new Vector( -composed.Size.X, composed.Size.Y );
            composed.Add( leftSubObject );

            Add( composed );
        }
    }
}
