﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;
using Jypeli.Controls;
using Jypeli.WP7;

public class Peli : Game
{
    public struct PalloData
    {
        public Vector paikka;
        public Vector nopeus;
    }

    const string fileName = "pallo.dat";

    GameObject pallo;
    PalloData data;

    public override void Begin()
    {
        Phone.DisplayOrientation = DisplayOrientation.Portrait;
        pallo = new GameObject( 50, 50, Shape.Circle );
        
        Camera.ZoomToLevel();

        if ( DataStorage.Exists( fileName ) )
        {
            MessageDisplay.Add( "Pallo tiedostosta" );
            data = (PalloData)DataStorage.Load<PalloData>( new PalloData(), fileName );
            pallo.Position = data.paikka;
        }
        else
        {
            MessageDisplay.Add( "Uusi pallo." );
            data = new PalloData();
            data.nopeus = Vector.FromLengthAndAngle( 5, RandomGen.NextAngle() );
        }

        Add( pallo );

        Timer liikeAjastin = new Timer();
        liikeAjastin.Interval = 0.01;
        liikeAjastin.Trigger += new Timer.TriggerHandler( LiikutaPalloa );
        liikeAjastin.Start();

        Timer.SingleShot( 10, TallennaJaLopeta );
    }

    void TallennaJaLopeta()
    {
        data.paikka = pallo.Position;
        DataStorage.Save<PalloData>( data, fileName );
        Exit();
    }

    void LiikutaPalloa( Timer timer )
    {
        Vector uusiPaikka = pallo.Position + data.nopeus;

        if ( uusiPaikka.X < Level.Left || uusiPaikka.X > Level.Right )
            data.nopeus = new Vector( -data.nopeus.X, data.nopeus.Y );
        if ( uusiPaikka.Y < Level.Bottom || uusiPaikka.Y > Level.Top )
            data.nopeus = new Vector( data.nopeus.X, -data.nopeus.Y );

        pallo.Position += data.nopeus;
    }
}