﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Effects;
using Jypeli.Widgets;

public class Peli : PhysicsGame
{
    public override void Begin()
    {
        Level.CreateBorders( 0.4, true );
        Gravity = new Vector( 0, -500 );

        GameObject olio = new GameObject( 40, 40 );
        olio.ArrivedAt += Perilla;
        olio.X = Level.Left;
        Add( olio );

        PhysicsObject fysOlio = new PhysicsObject( 80, 80, Shape.Circle );
        fysOlio.Mass = 10;
        fysOlio.ArrivedAt += Perilla;
        Add( fysOlio );

        Elephant norsu = new Elephant( 40, 40 );
        norsu.Mass = 100;
        norsu.Y = fysOlio.Y + fysOlio.Height * 2;
        Add( norsu );

        PhysicsObject taso = PhysicsObject.CreateStaticObject( 200, 40 );
        taso.Y = Level.Bottom + 200;
        Add( taso );

        PhysicsObject taso2 = PhysicsObject.CreateStaticObject( 200, 40 );
        taso2.Y = Level.Bottom + 300;
        taso2.Right = Level.Right;
        Add( taso2 );

        Mouse.IsCursorVisible = true;
        Mouse.Listen( MouseButton.Left, ButtonState.Down, LiikutaOliota, "Liikuta oliota", olio );
        Mouse.Listen( MouseButton.Right, ButtonState.Down, LiikutaOliota, "Liikuta fysiikkaoliota", fysOlio );
        Mouse.Listen( MouseButton.Middle, ButtonState.Down, LiikutaOliota, "Liikuta norsua", norsu );

        Keyboard.Listen( Key.Left, ButtonState.Down, LiikutaMovella, null, norsu, -200 * Vector.UnitX );
        Keyboard.Listen( Key.Right, ButtonState.Down, LiikutaMovella, null, norsu, 200 * Vector.UnitX );
        Keyboard.Listen( Key.Up, ButtonState.Pressed, LiikutaMovella, null, norsu, 600 * Vector.UnitY );
        Keyboard.Listen( Key.Down, ButtonState.Down, LiikutaMovella, null, norsu, -200 * Vector.UnitY );
        Keyboard.Listen( Key.Space, ButtonState.Down, Hyokkaa, "Voimahyökkäys", norsu, 400.0, 50.0, 3000.0 );

        //Keyboard.Listen( Key.Left, ButtonState.Down, norsu.Walk, null, Direction.Left );
        //Keyboard.Listen( Key.Right, ButtonState.Down, norsu.Walk, null, Direction.Right );
        //Keyboard.Listen( Key.Up, ButtonState.Pressed, Hyppaa, null, norsu, norsu.Mass * 400.0 );
    }

    void Hyppaa( PlatformCharacter hahmo, double impulssi )
    {
        hahmo.Jump( impulssi );
    }

    void Hyokkaa( PlatformCharacter hahmo, double xetaisyys, double yetaisyys, double nopeus )
    {
        double suuntaX = xetaisyys;
        if ( hahmo.FacingDirection == Direction.Left ) suuntaX = -suuntaX;
        hahmo.MoveTo( hahmo.Position + new Vector( suuntaX, yetaisyys ), nopeus );
    }

    void Perilla( GameObject liikkio, Vector obj )
    {
        liikkio.Color = Color.White;
    }

    void LiikutaOliota( GameObject liikkio )
    {
        liikkio.Color = Color.Red;
        liikkio.MoveTo( Mouse.PositionOnWorld, Level.Width / 30 );
    }

    void LiikutaMovella( GameObject liikkio, Vector suunta )
    {
        liikkio.Move( suunta );
    }
}
