﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Effects;
using Jypeli.Widgets;

public class Peli : PhysicsGame
{
    bool AutoAngle = false;

    public override void Begin()
    {
        Level.CreateBorders( 0.4, true );
        Gravity = new Vector( 0, -500 );

        GameObject olio = new GameObject( 40, 40 );
        olio.ArrivedAt += Perilla;
        olio.X = Level.Left;
        Add( olio );

        PhysicsObject fysOlio = new PhysicsObject( 80, 80, Shape.Circle );
        fysOlio.Y = 100;
        fysOlio.Mass = 100;
        fysOlio.ArrivedAt += Perilla;
        Add( fysOlio );

        Elephant2 norsu = new Elephant2( 40, 40 );
        norsu.Mass = 100;
        norsu.Y = fysOlio.Y + fysOlio.Height * 2;
        norsu.Acceleration = 600;
        norsu.MaxVelocity = 300;
        Add( norsu );

        //PhysicsObject taso = PhysicsObject.CreateStaticObject( 340, 400 );
        PhysicsObject taso = new PhysicsObject(340, 400);
        taso.Y = Level.Bottom + 220;
        Add( taso );

        PhysicsObject taso2 = PhysicsObject.CreateStaticObject( 200, 40 );
        taso2.Y = Level.Bottom + 300;
        taso2.Right = Level.Right;
        Add( taso2 );

        PhysicsObject kalteva = PhysicsObject.CreateStaticObject( 300, 40 );
        kalteva.X = -310;
        kalteva.Y = Level.Bottom + 300;
        kalteva.Angle = Angle.FromDegrees( -30 );
        Add( kalteva );

        Mouse.IsCursorVisible = true;
        Mouse.Listen( MouseButton.Left, ButtonState.Down, LiikutaOliota, "Liikuta oliota", olio );
        Mouse.Listen( MouseButton.Right, ButtonState.Down, LiikutaOliota, "Liikuta fysiikkaoliota", fysOlio );
        Mouse.Listen( MouseButton.Middle, ButtonState.Down, LiikutaOliota, "Liikuta norsua", norsu );

        Keyboard.Listen( Key.Left, ButtonState.Down, LiikutaMovella, null, norsu, -Vector.UnitX );
        Keyboard.Listen( Key.Right, ButtonState.Down, LiikutaMovella, null, norsu, Vector.UnitX );
        Keyboard.Listen( Key.Up, ButtonState.Pressed, LiikutaMovella, null, norsu, 600 * Vector.UnitY );
        Keyboard.Listen( Key.Space, ButtonState.Down, Hyokkaa, "Voimahyökkäys", norsu, 40.0, 50.0, 3000.0 );

        Keyboard.Listen( Key.NumPad8, ButtonState.Pressed, MuutaPainovoimaa, null, 100 * Vector.UnitY, norsu );
        Keyboard.Listen( Key.NumPad2, ButtonState.Pressed, MuutaPainovoimaa, null, -100 * Vector.UnitY, norsu );
        Keyboard.Listen( Key.NumPad4, ButtonState.Pressed, MuutaPainovoimaa, null, -100 * Vector.UnitX, norsu );
        Keyboard.Listen( Key.NumPad6, ButtonState.Pressed, MuutaPainovoimaa, null, 100 * Vector.UnitX, norsu );

        Keyboard.Listen( Key.Back, ButtonState.Pressed, TogglaaAutomaattiKulma, null );

        //Keyboard.Listen( Key.Left, ButtonState.Down, norsu.Walk, null, Direction.Left );
        //Keyboard.Listen( Key.Right, ButtonState.Down, norsu.Walk, null, Direction.Right );
        //Keyboard.Listen( Key.Up, ButtonState.Pressed, Hyppaa, null, norsu, norsu.Mass * 400.0 );
    }

    void Hyppaa( PlatformCharacter2 hahmo, double nopeus )
    {
        hahmo.Jump( nopeus );
    }

    void Hyokkaa( PlatformCharacter2 hahmo, double xetaisyys, double yetaisyys, double nopeus )
    {
        double suuntaX = xetaisyys;
        if ( hahmo.FacingDirection == Direction.Left ) suuntaX = -suuntaX;
        hahmo.MoveTo( hahmo.Position + new Vector( suuntaX, yetaisyys ), nopeus );
    }

    void Perilla( GameObject liikkio, Vector obj )
    {
        liikkio.Color = Color.White;
    }

    void LiikutaOliota( GameObject liikkio )
    {
        liikkio.Color = Color.Red;
        liikkio.MoveTo( Mouse.PositionOnWorld, Level.Width / 30 );
    }

    void LiikutaMovella( PlatformCharacter2 liikkio, Vector suunta )
    {
        if ( AutoAngle && liikkio.Platform != null )
        {
            //Angle kulma = liikkio.Platform.Angle;
            //Gravity = Vector.FromLengthAndAngle( Gravity.Magnitude, kulma - Angle.RightAngle );
            //liikkio.Angle = kulma;
            Angle kulma = liikkio.PlatformNormal.Angle;
            Gravity = Vector.FromLengthAndAngle( Gravity.Magnitude, kulma );
            liikkio.Angle = Gravity.Angle + Angle.RightAngle;
        }

        liikkio.Move( suunta );
    }

    void MuutaPainovoimaa( Vector muutos, PhysicsObject pelaaja )
    {
        Gravity += muutos;

        if ( Gravity == Vector.Zero )
            pelaaja.Angle = Angle.Zero;
        else
            pelaaja.Angle = Gravity.Angle + Angle.RightAngle;

        MessageDisplay.Add( "Painovoima: " + Gravity );
    }

    void TogglaaAutomaattiKulma()
    {
        AutoAngle = !AutoAngle;
        MessageDisplay.Add( "AutoAngle: " + (AutoAngle ? "ON" : "OFF") );
    }
}
