﻿using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Effects;
using Jypeli.Widgets;

public class Peli : PhysicsGame
{
    Image kuvaOikealle;
    Image kuvaVasemmalle;

    PhysicsObject ukko;

    public override void Begin()
    {
        Level.BackgroundColor = Color.SkyBlue;

        kuvaOikealle = LoadImage("skate_ninja");
        kuvaVasemmalle = Image.Mirror(kuvaOikealle);

        Level.Width = 5000;
        Level.Height = 1000;
        PhysicsObject vasenReuna = Level.CreateLeftBorder(0.3, true);
        PhysicsObject oikeaReuna = Level.CreateRightBorder(0.3, true);
        vasenReuna.Color = Color.LightCyan;
        oikeaReuna.Color = Color.LightCyan;
        Level.CreateGround(260, 300, 40);

        Camera.ZoomFactor = 1.7;
        Gravity = -1000 * Vector.UnitY;

        ukko = new PhysicsObject(30, 50);
        ukko.MomentOfInertia = Double.PositiveInfinity;
        ukko.Mass = 800;
        ukko.X = Level.Left + ukko.Width;
        ukko.Y = Level.GetGroundHeight(ukko.X) + 30;
        ukko.Image = kuvaOikealle;
        Add(ukko);
        Camera.Follow(ukko);

        Keyboard.Listen(Key.Left, ButtonState.Down, Liikuta, null, ukko, -1000.0);
        Keyboard.Listen(Key.Right, ButtonState.Down, Liikuta, null, ukko, 1000.0);
        Keyboard.Listen(Key.Space, ButtonState.Pressed, Hyppaa, null, ukko, 300.0);

        /*for (double x = Level.Left; x < Level.Right; x += Level.Width / 100)
        {
            double y = Level.GetGroundHeight(x);
            Vector n = Level.GetGroundNormal(x);

            GameObject merkki = new GameObject(5, 5, Shape.Circle);
            merkki.Color = Color.Red;
            merkki.Position = new Vector(x, y);
            Add(merkki);

            PhysicsObject norm = new PhysicsObject(new RaySegment(merkki.Position, n, 50));
            norm.Color = Color.Blue;
            norm.IgnoresGravity = true;
            norm.IgnoresCollisionResponse = true;
            norm.MomentOfInertia = double.PositiveInfinity;
            Add(norm);
        }*/
    }

    public bool KoskettaaMaata(PhysicsObject olio)
    {
        return olio.Bottom - Level.GetGroundHeight(ukko.X) < 5;
    }

    public void Liikuta(PhysicsObject olio, double kiihtyvyys)
    {
        if (kiihtyvyys < 0)
            ukko.Image = kuvaVasemmalle;
        else
            ukko.Image = kuvaOikealle;

        olio.Push(olio.Mass * kiihtyvyys * Vector.UnitX);
    }

    public void Hyppaa(PhysicsObject olio, double nopeus)
    {
        if ( KoskettaaMaata(olio) )
            olio.Hit(olio.Mass * nopeus * Vector.UnitY);
    }

    protected override void Update(Microsoft.Xna.Framework.GameTime gameTime)
    {
        if ( KoskettaaMaata(ukko) )
            ukko.Angle = Level.GetGroundNormal(ukko.X).Angle - Angle.RightAngle;

        base.Update(gameTime);
    }
}
