﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;

namespace Jypeli.SimplePhysics
{
    public sealed class ConstantImpulse : Impulse
    {
        Vector force;
        bool immortal;
        long lifeCyclesLeft;

        public bool IsExpired { get; private set; }

        public ConstantImpulse( Vector force )
        {
            this.force = force;
            this.immortal = true;
        }

        public ConstantImpulse(Vector force, double t)
        {
            this.force = force;
            this.lifeCyclesLeft = (long)( t / SimplePhysicsGame.dt );
            this.IsExpired = lifeCyclesLeft <= 0;
        }

        #region Impulse Members

        public Vector GetNextForce()
        {
            if ( IsExpired )
                return Vector.Zero;

            if ( !immortal && lifeCyclesLeft <= 0 )
            {
                IsExpired = true;
                return Vector.Zero;
            }

            lifeCyclesLeft--;
            return force;
        }

        #endregion
    }
}
