﻿using System;
using Jypeli;
using Jypeli.Controls;
using Jypeli.Assets;

namespace SurfaceTest
{
    public class Peli : TopDownPhysicsGame
    {
        public override void Begin()
        {
            Level.CreateBorders();
            KineticFriction = 0.0;
            Gravity = 9;

            CreateTrack();

            var surface = PhysicsObject.CreateStaticObject( 200, 200 );
            surface.Color = Color.Gray;
            surface.KineticFriction = 1.0;
            //AddSurface( surface );

            var thing = new PhysicsObject( 20, 20, Shape.Rectangle );
            thing.Mass = 10;
            thing.X = -300;
            thing.Color = Color.Green;
            Add( thing );

            double force = 500;

            Keyboard.Listen( Key.Left, ButtonState.Down, thing.Push, null, new Vector( -force, 0 ) );
            Keyboard.Listen( Key.Right, ButtonState.Down, thing.Push, null, new Vector( force, 0 ) );
            Keyboard.Listen( Key.Up, ButtonState.Down, thing.Push, null, new Vector( 0, force ) );
            Keyboard.Listen( Key.Down, ButtonState.Down, thing.Push, null, new Vector( 0, -force ) );
            Keyboard.Listen( Key.Escape, ButtonState.Pressed, Exit, null );
        }

        void CreateTrack()
        {
            Vector[] wayPoints = new Vector[]
            {
                new Vector( -100, 200 ), 
                new Vector( 100, 200 ),
                new Vector( 150, 150 ),
                new Vector(200, 0),
                new Vector(100, -80),
                new Vector(100, -200),
            };

            RoadMap b = new RoadMap( wayPoints );
            b.DefaultWidth = 100;
            b.Insert();
    }
    }
}
