﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Jypeli;
using Jypeli.Controls;
using Jypeli.Widgets;
using Jypeli.WP7;

public class Peli : PhysicsGame
{
    static readonly Color[] colors =
    {
        Color.White,
        Color.Black,
        Color.Blue,
        Color.Green,
        Color.Red,
        Color.Orange,
        Color.Yellow,
        Color.Pink,
    };

    Color drawColor = Color.Orange;

    public override void Begin()
    {
        Level.Width = 480;
        Level.Height = 800;
        Camera.ZoomFactor = 0.5;
        //Camera.ZoomFactor = 1.0;
        TouchPanel.Listen(ButtonState.Pressed, AddBall, null, Color.Green, 1);
        TouchPanel.Listen(ButtonState.Down, AddBall, null, Color.Gray, 0);
        TouchPanel.Listen(ButtonState.Released, AddBall, null, Color.Red, 1);

        Widget panel = new Widget(100, Screen.Height);
        panel.Layout = new VerticalLayout();
        panel.X = Screen.Left + panel.Width / 2;
        panel.Y = Screen.Center.Y;
        Add(panel);

        foreach (Color color in colors)
        {
            Widget button = new Widget(100, 80) { Color = color };
            panel.Add(button);
            TouchPanel.ListenOn(button, ButtonState.Pressed, SetDrawColor, null, color);
        }
    }

    void AddBall(Touch touch, Color color, int layer)
    {
        GameObject ball = new GameObject(20, 20, Shape.Circle);
        ball.MaximumLifetime = TimeSpan.FromSeconds(10);
        ball.Color = color;
        ball.Position = touch.PositionOnWorld;
        Add(ball, layer);

        Vector movement = touch.MovementOnWorld;
        GameObject movementVector = new GameObject(Math.Max(movement.Magnitude, 1), 10, Shape.Rectangle);
        movementVector.Position = touch.PositionOnWorld - movement / 2;
        movementVector.Angle = movement.Angle;
        movementVector.MaximumLifetime = TimeSpan.FromSeconds(10);
        movementVector.Color = drawColor;
        Add(movementVector);
    }

    void SetDrawColor(Touch touch, Color color)
    {
        drawColor = color;
    }
}
