﻿using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Effects;
using Jypeli.Widgets;

public class Peli : PhysicsGame
{
    public override void Begin()
    {
        Gravity = -500 * Vector.UnitY;
        Level.BackgroundColor = Color.Black;
        Level.CreateBorders();

        PlatformCharacter ukko = new PlatformCharacter( 30, 70 );
        ukko.Y = Level.Bottom + 15;
        Add( ukko );

        AssaultRifle ase1 = new AssaultRifle( 28, 12 );
        ase1.X = ukko.Width / 2;
        PlasmaCannon ase2 = new PlasmaCannon( 28, 12 );
        ase2.X = ukko.Width / 2;

        PlatformCharacter2 ukko2 = new PlatformCharacter2( 30, 70 );
        ukko2.Acceleration = 500;
        ukko2.MaxVelocity = 300;
        ukko2.X = 400;
        ukko2.Y = Level.Bottom + 50;
        Add( ukko2 );

        AssaultRifle ase3 = new AssaultRifle( 28, 12 );
        ase3.X = ukko2.Width / 2;
        PlasmaCannon ase4 = new PlasmaCannon( 28, 12 );
        ase4.X = ukko2.Width / 2;

        Keyboard.Listen( Key.Left, ButtonState.Down, ukko.Walk, null, -300.0 );
        Keyboard.Listen( Key.Right, ButtonState.Down, ukko.Walk, null, 300.0 );
        Keyboard.Listen( Key.Up, ButtonState.Pressed, delegate { ukko.Jump( 700.0 ); }, null );
        Keyboard.Listen( Key.Space, ButtonState.Down, Ammu, null, ukko );
        Keyboard.Listen( Key.H, ButtonState.Pressed, ValitseAse, null, ukko, (Weapon)null );
        Keyboard.Listen( Key.D1, ButtonState.Pressed, ValitseAse, null, ukko, ase1 );
        Keyboard.Listen( Key.D2, ButtonState.Pressed, ValitseAse, null, ukko, ase2 );

        Keyboard.Listen( Key.NumPad4, ButtonState.Down, ukko2.Walk, null, Direction.Left );
        Keyboard.Listen( Key.NumPad6, ButtonState.Down, ukko2.Walk, null, Direction.Right );
        Keyboard.Listen( Key.NumPad8, ButtonState.Pressed, delegate { ukko2.Jump( 700.0 ); }, null );
        Keyboard.Listen( Key.NumPad0, ButtonState.Down, Ammu2, null, ukko2 );
        Keyboard.Listen( Key.Subtract, ButtonState.Pressed, ValitseAse2, null, ukko2, (Weapon)null );
        Keyboard.Listen( Key.Divide, ButtonState.Pressed, ValitseAse2, null, ukko2, ase3 );
        Keyboard.Listen( Key.Multiply, ButtonState.Pressed, ValitseAse2, null, ukko2, ase4 );
    }

    void Ammu( PlatformCharacter ukko )
    {
        if ( ukko.Weapon != null )
        {
            PhysicsObject ammus = ukko.Weapon.Shoot();
            if ( ammus != null ) Add( ammus );
        }
    }

    void ValitseAse( PlatformCharacter ukko, Weapon ase )
    {
        ukko.Weapon = ase;
    }

    void Ammu2( PlatformCharacter2 ukko )
    {
        if ( ukko.Weapon != null )
        {
            PhysicsObject ammus = ukko.Weapon.Shoot();
            if ( ammus != null ) Add( ammus );
        }
    }

    void ValitseAse2( PlatformCharacter2 ukko, Weapon ase )
    {
        ukko.Weapon = ase;
    }
}
