﻿using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Effects;
using Jypeli.Widgets;

public class Peli : PhysicsGame
{
    PhysicsStructure structure;

    public override void Begin()
    {
        Level.CreateBorders( 1.0, true );
        Gravity = new Vector( 0, -500 );

        LuoRakenne();

        IsMouseVisible = true;
        Mouse.Listen( MouseButton.Left, ButtonState.Pressed, LisaaPallo, null );
        Mouse.Listen( MouseButton.Right, ButtonState.Pressed, TuhoaRakenne, null );
    }

    void LisaaPallo()
    {
        PhysicsObject pallo = new PhysicsObject( 30, 30, Shape.Circle );
        pallo.Color = Color.Black;
        pallo.Position = Mouse.PositionOnWorld;
        pallo.Restitution = 0.7;
        structure.Add( pallo );
    }

    void LuoRakenne()
    {
        structure = new PhysicsStructure();
        structure.Softness = 0.5;
        Add( structure );
    }

    void TuhoaRakenne()
    {
        structure.Destroy();
        LuoRakenne();
    }
}
