﻿using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Effects;
using Jypeli.Widgets;
using Jypeli.WP7;

public class Peli : PhysicsGame
{
    [Save] public PhysicsObject Magneetti;
    PhysicsObject JattiMagneetti;
    Image hahmo = LoadImage("örkki");
    [Save] public GameObject Risti;
    Image liikuttaja = LoadImage("risti");
    [Save] public IntMeter pisteLaskuri;
    Image lopputeksti = LoadImage("lopputeksti");
    List<Label> valikonKohdat;
    bool pelikaynnissa = false;
    [Save] public bool jatkettuPeli;
    [Save] public bool valikossa;

    EasyHighScore topLista = new EasyHighScore("magneettitopten.xml", 10, "");
    

    [Save] public int kenttanro = 1;


    public override void Begin()
    {
        jatkettuPeli = false;
        valikossa = true;
        tallennaTila();
        Valikko();
        
    }

    public override void Continue()
    {
        //jatkettuPeli = false;
        //bool valikossa = false;
        LoadState tilanteenLataus = DataStorage.BeginLoad("pelitilanne.xml");
        jatkettuPeli = tilanteenLataus.Load<bool>(jatkettuPeli, "jatkettu");
        valikossa = tilanteenLataus.Load<bool>(valikossa, "valikossa");
        kenttanro = tilanteenLataus.Load<int>(kenttanro, "kenttanro");
        tilanteenLataus.EndLoad();

        if (valikossa)
            Valikko();
        else
            AloitaPeli();
    }

    void tallennaTila()
    {
        SaveState tilanneTallennus = DataStorage.BeginSave("pelitilanne.xml");
        tilanneTallennus.Save<bool>(jatkettuPeli, "jatkettu");
        tilanneTallennus.Save<bool>(valikossa, "valikossa");
        tilanneTallennus.Save<int>(kenttanro, "kenttanro");
        tilanneTallennus.EndSave();
    }

    void PalaaValikkoon()
    {
        
        
        SaveGame("magneetti.xml");
        jatkettuPeli = true;
        valikossa = true;
        tallennaTila();
        Valikko();
    }

    void JatkaPelia()
    {
        valikossa = false;
        jatkettuPeli = true;
        tallennaTila();
        AloitaPeli();
    }

    void JatkaPelia(Touch kosketus)
    {
        valikossa = false;
        jatkettuPeli = true;
        tallennaTila();
        AloitaPeli();
    }

    void Valikko()
    {

        ClearAll();

        Magneetti = new PhysicsObject(50, 50);
        Risti = new GameObject(200, 200);
        pisteLaskuri = new IntMeter(0);
        Level.BackgroundColor = Color.SkyBlue;
        Level.Width = 800;
        Level.Height = 480;
        valikonKohdat = new List<Label>();

        Label ohjeet = new Label("Ohjaa hiirellä ristiä. Risti hylkii magneettia.\n" +
        "Ohjaa magneetti maaliin osumatta seiniin\n tai toiseen magneettiin." +
        "Mitä vähemmän pisteitä,\n sen parempi.Lopettaaksesi pelin,\n paina ESC-näppäintä.");
        ohjeet.Y = 40;
        ohjeet.Width = 20;
        ohjeet.Font = Font.DefaultSmall;
        //ohjeet.HorizontalSizing = Sizing.FixedSize;
        ohjeet.SizeMode = TextSizeMode.Wrapped;
        Add(ohjeet);

        Label kohtaJatkettu = new Label("Jatka peliä");
        kohtaJatkettu.Position = new Vector(0, -20);
        kohtaJatkettu.Font = Font.DefaultSmall;
        if (jatkettuPeli)
            valikonKohdat.Add(kohtaJatkettu);

        Label kohta1 = new Label("Aloita uusi peli");
        kohta1.Position = new Vector(0, -50);
        kohta1.Font = Font.DefaultSmall;
        valikonKohdat.Add(kohta1);

        Label kohta2 = new Label("Lopeta");
        kohta2.Position = new Vector(0, -90);
        kohta2.Font = Font.DefaultSmall;
        valikonKohdat.Add(kohta2);

        foreach (Label valikonKohta in valikonKohdat)
        {
            Add(valikonKohta);
        }
#if WINDOWS_PHONE
        TouchPanel.ListenOn(kohta1, ButtonState.Pressed, AloitaUusiPeli, null);
        TouchPanel.ListenOn(kohta2, ButtonState.Pressed, Lopeta, null);
        if (jatkettuPeli)
        {
            TouchPanel.ListenOn(kohtaJatkettu, ButtonState.Pressed, JatkaPelia, null);
            PhoneBackButton.Listen(JatkaPelia, "");
        }
        else
            PhoneBackButton.Listen(Exit, "");
#endif
        Mouse.ListenOn(kohta1, MouseButton.Left, ButtonState.Pressed, AloitaUusiPeli, null);
        Mouse.ListenOn(kohta2, MouseButton.Left, ButtonState.Pressed, Lopeta, null);
        if (jatkettuPeli)
            Mouse.ListenOn(kohtaJatkettu, MouseButton.Left, ButtonState.Pressed, JatkaPelia, null);
        Mouse.IsCursorVisible = true;
        Mouse.ListenMovement(1.0, ValikossaLiikkuminen, null);
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, Lopeta, "");
        //Camera.ZoomToLevel();
    }

    void ValikossaLiikkuminen(AnalogState hiirenTila)
    {
        foreach (Label kohta in valikonKohdat)
        {
            if (Mouse.IsCursorOn(kohta))
            {
                kohta.TextColor = Color.Red;
            }
            else
            {
                kohta.TextColor = Color.Black;
            }

        }
    }

    void AloitaUusiPeli(Touch kosketus)
    {
        jatkettuPeli = false;
        valikossa = false;
        tallennaTila();
        AloitaPeli();
    }

    void AloitaUusiPeli()
    {
        jatkettuPeli = false;
        valikossa = false;
        tallennaTila();
        AloitaPeli();
    }

    void AloitaPeli()
    {
        pelikaynnissa = true;
        ClearAll();
        Level.Width = 800;
        Level.Height = 480;
        if (valikossa)
        {
            Valikko();
            return;
        }
        AsetaOhjaimet();
       // kenttanro = 4;
        //LuoKentta(4);
        LuoKentta(kenttanro);
        
        if (jatkettuPeli)
            LoadGame("magneetti.xml");
        
        //Level.CreateBorders();

        // Keyboard.Listen(Key.Escape, ButtonState.Pressed, Valikko, "Palaa valikkoon");
    }

    void Lopeta(Touch kosketus)
    {
        Lopeta();
    }

    void Lopeta()
    {
        Exit();
    }

    #region kentanluonti

    void LuoKentta(int kenttanro)
    {
        String kentta;
        ClearControls();
        ClearGameObjects();
        ClearWidgets();

        switch (kenttanro)
        {
            case 1: 
                kentta = "kentta"; 
                Level.BackgroundColor = Color.LimeGreen;
                break;
            case 2: 
                kentta = "kentta2"; 
                Level.BackgroundColor = Color.LimeGreen;
                break;
            case 3: 
                kentta = "kentta3";
                Level.BackgroundColor = Color.LimeGreen;
                break;
            case 4: 
                kentta = "bonuskentta"; 
                Level.BackgroundColor = Color.Aqua;
                break;
            default: kentta = ""; Exit(); break;
        }

        //switch (kenttanro)
        //{
        //    case 1: 
        //        kentta = "kentta.txt"; 
        //        Level.BackgroundColor = Color.LimeGreen;
        //        break;
        //    case 2: 
        //        kentta = "kentta2.txt"; 
        //        Level.BackgroundColor = Color.LimeGreen;
        //        break;
        //    case 3: 
        //        kentta = "kentta3.txt";
        //        Level.BackgroundColor = Color.LimeGreen;
        //        break;
        //    case 4: 
        //        kentta = "bonuskentta.txt"; 
        //        Level.BackgroundColor = Color.Aqua;
        //        break;
        //    default: kentta = ""; Exit(); break;
        //}

        //if (DataStorage.Exists("pisteet" + kenttanro + ".xml"))
             topLista = new EasyHighScore("pisteet" + kenttanro + ".xml", 10, "Magneetti");
            //topLista = DataStorage.Load<ScoreList>(topLista, "pisteet" + kenttanro + ".xml");
        LuoRisti();
        LuoLaskuri();

        TileMap ruudut = TileMap.FromLevelAsset(kentta);

        //TileMap ruudut = TileMap.FromFile(kentta);

        ruudut.SetTileMethod('x', LuoPalikka);
        ruudut.SetTileMethod('p', LuoPuu);
        ruudut.SetTileMethod('o', LuoMaali);
        ruudut.SetTileMethod('j', LuoJarvi);
        ruudut.SetTileMethod('k', LuoKukka);
        ruudut.SetTileMethod('$', LuoMagneetti);
        ruudut.SetTileMethod('r', LuoRanta);
        ruudut.SetTileMethod('M', LuoJattiMagneetti);
        ruudut.SetTileMethod ('R', LuoBonusRanta);

        ruudut.Execute(50, 50);
        Level.CreateBorders(1.0, false);
        Camera.ZoomFactor = 1.0;
        Camera.FollowedObject = Magneetti;
        AsetaOhjaimet();
        tallennaTila();
        //Camera.ZoomToLevel();
    }

    void LuoBonusRanta(Vector paikka, double leveys, double korkeus)
    {
        
        GameObject BonusRanta = new GameObject(16 * leveys, 3 * korkeus );
        BonusRanta.Image = LoadImage("bonusranta");
        BonusRanta.Position = new Vector(paikka.X + BonusRanta.Width/2 - leveys / 2, paikka.Y - BonusRanta.Height/2+ korkeus/2);
        //BonusRanta.Position = paikka;
        Add(BonusRanta);
    }

    void LuoPalikka(Vector paikka, double leveys, double korkeus)
    {
        PhysicsObject palikka = PhysicsObject.CreateStaticObject(leveys, korkeus);
        palikka.Position = paikka;
        palikka.Tag = "x";
        palikka.Color = Color.Orange;
        Add(palikka);

    }

    void LuoPuu(Vector paikka, double leveys, double korkeus)
    {
        PhysicsObject puu = PhysicsObject.CreateStaticObject(leveys, korkeus);
        puu.Image = LoadImage("puu");
        puu.Position = paikka;

        Add(puu);
    }

    void LuoMaali(Vector paikka, double leveys, double korkeus)
    {
        PhysicsObject maali = PhysicsObject.CreateStaticObject(leveys, korkeus);
        maali.Image = LoadImage("maali");
        maali.Position = paikka;
        maali.Tag = "o";
        Add(maali);
    }

    void LuoJarvi(Vector paikka, double leveys, double korkeus)
    {
        GameObject jarvi = new GameObject(leveys * 8, korkeus);
        jarvi.Image = LoadImage("järvi");
        jarvi.Position = new Vector(paikka.X + jarvi.Width / 2 - leveys / 2, paikka.Y);
        Add(jarvi);
    }

    void LuoKukka(Vector paikka, double leveys, double korkeus)
    {
        PhysicsObject kukka = PhysicsObject.CreateStaticObject (leveys, korkeus);
        kukka.Image = LoadImage("kukka");
        kukka.Position = paikka;
        Add(kukka);
    }

    void LuoMagneetti(Vector paikka, double leveys, double korkeus)
    {
        Magneetti = new PhysicsObject(20, 20);
        Magneetti.Shape = Shape.Circle;
        Magneetti.Position = paikka;
        Magneetti.Image = hahmo;
        Magneetti.CanRotate = false;
        Magneetti.Restitution = 0.25;
        AddCollisionHandler(Magneetti, KasitteleMagneetinTormays);

        Add(Magneetti, 1);

    }

    void LuoRanta(Vector paikka, double leveys, double korkeus)
    {
        GameObject Ranta = new GameObject(3 * leveys, korkeus);
        Ranta.Image = LoadImage("beach");
        Ranta.Position = new Vector(paikka.X + Ranta.Width / 1.5 - leveys / 2, paikka.Y);
        Add(Ranta);

    }


    void LuoJattiMagneetti(Vector paikka, double leveys, double korkeus)
    {
        JattiMagneetti = PhysicsObject.CreateStaticObject(50, 50);
        JattiMagneetti.Image = LoadImage("jättimagneetti");
        JattiMagneetti.Position = paikka;
        JattiMagneetti.Tag = "M";
        Add(JattiMagneetti);

    }

    void LuoRisti()
    {
        Risti = new GameObject(200, 200);
        Risti.Shape = Shape.Circle;
        Risti.Image = liikuttaja;
        Add(Risti, 1);

    }

    #endregion 

    void AsetaOhjaimet()
    {
        Mouse.IsCursorVisible = false;
        Mouse.ListenMovement(0.1, KuunteleLiiketta, null);
#if WINDOWS_PHONE
        TouchPanel.Listen(ButtonState.Down, KuunteleLiiketta, null);
        PhoneBackButton.Listen(PalaaValikkoon, "Mene valikkoon");
#endif
        Keyboard.Listen(Key.P, ButtonState.Pressed, PalaaValikkoon, "");
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, Exit, "Lopeta Peli");

    }

    void KuunteleLiiketta(Touch kosketus)
    {
        Risti.X = kosketus.PositionOnWorld.X;
        Risti.Y = kosketus.PositionOnWorld.Y;
    }

    void KuunteleLiiketta(AnalogState hiirentila)
    {
        Risti.X = Mouse.PositionOnWorld.X;
        Risti.Y = Mouse.PositionOnWorld.Y;
    }

    void LuoLaskuri()
    {
        pisteLaskuri = new IntMeter(0);
        pisteLaskuri.MinValue = int.MinValue;
        Label pisteNaytto = new Label();
        pisteNaytto.X = Screen.Right - 100;
        pisteNaytto.Y = Screen.Top - 100;
        pisteNaytto.TextColor = Color.White;
        pisteNaytto.BindTo(pisteLaskuri);
        Add(pisteNaytto);
    }

    void KasitteleMagneetinTormays(PhysicsObject Magneetti, PhysicsObject kohde)
    {
        // Seinä
        if (kohde.Tag.ToString() == "x")
        {
            pisteLaskuri.Value++;
        }

        // Iso magneetti
        if (kohde.Tag.ToString() == "M")
        {
            pisteLaskuri.Value += 100;
        }

        // Loppu eli maali
        if (kohde.Tag.ToString() == "o")
        {
            //Camera.ZoomFactor = 1.0;
            //Camera.ZoomToLevel();
            GameObject loppu = new GameObject(226, 29);
            Magneetti.Destroy();
            loppu.Image = lopputeksti;

            Add(loppu);
            pisteLaskuri.MaxValue = pisteLaskuri.Value;
            Label loppupiste = new Label();
            loppupiste.Y = -40;
            loppupiste.BindTo(pisteLaskuri);
            Add(loppupiste);
            if ((kenttanro == 4 && pisteLaskuri.Value <= 1) || (kenttanro != 4 && pisteLaskuri.Value <= 1000))
            {
                /*HighScoreWindow topIkkuna = new HighScoreWindow("Magneetti",
                                 "Parhaat pisteet",
                                 "Onneksi olkoon, pääsit listalle pisteillä %p! Syötä nimesi:",
                                 topLista, pisteLaskuri.Value);
                topIkkuna.Closed += TallennaPisteet;
                Add(topIkkuna);*/
                
                topLista.EnterText = string.Format("Onneksi olkoon, pääsit listalle pisteillä {0}! Syötä nimesi:", pisteLaskuri.Value);
                topLista.Text = "Parhaat pisteet";
                topLista.EnterAndShow(pisteLaskuri.Value);
            }
            else
            {
                topLista.Show();
                //HighScoreWindow topIkkuna = new HighScoreWindow("Magneetti",
                //                 "Parhaat pisteet",
                //                 topLista);
                //Add(topIkkuna);
            }
            //ClearControls();
            TouchPanel.Listen(ButtonState.Pressed, delegate { LuoKentta(++kenttanro); }, "");
        }
    }

    void TallennaPisteet(Window sender)
    {
        //DataStorage.Save<ScoreList>(topLista, "pisteet" + kenttanro + ".xml");
        //LuoKentta(++kenttanro);
    }

    protected override void Update(Time time)
    {

        // SetWindowSize(1024, 768, false);
        if (pelikaynnissa && !valikossa)
        {

            Vector v = Magneetti.Position - Risti.Position;
            // MessageDisplay.Add(v.X + " " + v.Y);
            Magneetti.Push(1000 / v.Magnitude * v.Normalize());

            Vector z = JattiMagneetti.Position - Magneetti.Position;
            Magneetti.Push(1500 / z.Magnitude * z.Normalize());
        }

        base.Update(time);
    }
}
