﻿using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Widgets;
using Jypeli.Assets;
using Jypeli.WP7;
using Jypeli.Effects;

namespace Ping_Pong
{
    public class Peli : PhysicsGame
    {
        //PhysicsObject pallo;
        [Save] public PhysicsObject pelihahmo;
        [Save] public List<PhysicsObject> viholliset = new List<PhysicsObject>();

        GameObject isoPilvi;
        GameObject pieniPilvi;
        GameObject miniPilvi;

        Timer ajastin;
        Timer aikalaskuri;
        [Save] public DoubleMeter aikamittari;
         
        Label aikanaytto;

        Image alkuKuva = LoadImage("aloitusruutu");
        Image vasenReunaKuva = LoadImage("vasenreuna");
        Image alaReunaKuva = LoadImage("alareuna");
        Image ylaReunaKuva = LoadImage("ylareuna");
        Image oikeaReunaKuva = LoadImage("oikeareuna");
        Image pilvenAlphaKuva = LoadImage("pilviAlpha");
        Image pilvenKuva = LoadImage("pilvi");
        Image pilvenKuvaPeilattu;
        Image pikkiPallonKuva = LoadImage("Piikkipallo2");
        Image[] ilmapallonKuvat = LoadImages("Ilmapallo", "Ilmapallo2", "Ilmapallo3");
        Animation ilmapallonAnimaatioVasemmalle;
        Animation ilmapallonAnimaatioOikealle;

        //SoundEffect popSound = LoadSoundEffect("Balloon Popping-SoundBible.com-1247261379"); // Recorded by Mike Koening

        EasyHighScore topLista;

        ExplosionSystem rajahdys;

        int impulssinVoima = 400;

        [Save] public bool peliJatkettu = false;
        [Save] public bool peliPausella = false; 

        public override void Begin()
        {

            //TODO: testaa toimiiko tämä.
            //if (MediaPlayer.State == Microsoft.Xna.Framework.Media.MediaState.Stopped || MediaPlayer.State == Microsoft.Xna.Framework.Media.MediaState.Paused)
            //{
                //MediaPlayer.Play("jackie1-kiko_Hdz-6204_hifi");
                //MediaPlayer.IsRepeating = true;
            //}

            pilvenKuvaPeilattu = Image.Mirror(pilvenKuva);
            ilmapallonAnimaatioVasemmalle = new Animation(ilmapallonKuvat);
            ilmapallonAnimaatioVasemmalle.FPS = 8;
            ilmapallonAnimaatioVasemmalle.Start();
            
            ilmapallonAnimaatioOikealle = new Animation(Image.Mirror(ilmapallonKuvat));
            ilmapallonAnimaatioOikealle.FPS = 8;
            ilmapallonAnimaatioOikealle.Start();

            Alku();

            ClearControls();

            peliPausella = true;

            this.PhysicsEnabled = false;

            ajastin.Pause();
            aikalaskuri.Pause();
            
            //aikanaytto.Destroy();
            //Level.Width = 800;
            //Level.Height = 480;

            //Phone.DisplayResolution = DisplayResolution.Large;

            GameObject alkuruutu = new GameObject(Level.Width, Level.Height);
            alkuruutu.Image = alkuKuva;
            Add(alkuruutu);

            GameObject alkuPallo = new GameObject(50.0, 50.0);
            alkuPallo.Animation = ilmapallonAnimaatioOikealle;
            alkuPallo.Position = new Vector(Level.Left + 170, Level.Top - 125);
            Add(alkuPallo);

            isoPilvi.IsVisible = false;

            TouchPanel.Listen(ButtonState.Pressed, delegate {
                alkuruutu.Destroy();
                alkuPallo.Destroy();
                isoPilvi.IsVisible = true;

                ClearControls();
                AsetaOhjaimet();

                peliPausella = false;
                this.PhysicsEnabled = true;
                ajastin.Start();
                
                aikalaskuri.Start();
                
            }, null);
            PhoneBackButton.Listen(Exit, null);

        }

        public override void Continue()
        {
            //MediaPlayer.Play("jackie1-kiko_Hdz-6204_hifi");
            //MediaPlayer.IsRepeating = true;

            pilvenKuvaPeilattu = Image.Mirror(pilvenKuva);
            ilmapallonAnimaatioVasemmalle = new Animation(ilmapallonKuvat);
            ilmapallonAnimaatioOikealle = new Animation(Image.Mirror(ilmapallonKuvat));
            
            peliJatkettu = true;
            
            AddFactory<PhysicsObject>("pallo", LuoPiikkiPallo);
            
            Alku();
            viholliset = DataStorage.Load<List<PhysicsObject>>(viholliset, "enemies.xml");
            
            Timer.SingleShot(0.1, AsetaPause);
        }

        protected override void OnExiting(object sender, EventArgs args)
        {
            DataStorage.Save<List<PhysicsObject>>(viholliset, "enemies.xml");
            
            base.OnExiting(sender, args);
        }

        void Alku()
        {
            ClearAll();

            impulssinVoima = 400;

            topLista = new EasyHighScore(10);
            topLista.HighScoreWindow.Closed += Lopeta;

            //Phone.DisplayOrientation = Jypeli.WP7.DisplayOrientation.LandscapeLeft;
            Phone.DisplayResolution = DisplayResolution.Large;
            IsFullScreen = true;

            Level.Width = 800;
            Level.Height = 480;

            LuoReunat();
            LuoPilvet();
            LuoPeliHahmo();
            
            if (!peliJatkettu) 
            {
                viholliset.Clear();
                viholliset.Add( LuoPiikkiPallo() );
                Add(pelihahmo);
            }

            AsetaOhjaimet();

            LuoAikaLaskuri();
            LuoVihollisAjastin();
            
            rajahdys = new ExplosionSystem(ilmapallonKuvat[0], 100);
            rajahdys.MinLifetime = 5;
            rajahdys.MaxLifetime = 10;
            Add(rajahdys, 3);

            Level.BackgroundColor = new Color(170, 237, 255); 

        }

        void LuoVihollisAjastin()
        {
            ajastin = new Timer();
            ajastin.Interval = 2;
            ajastin.Timeout += Ajastinapu;
            //ajastin.Reset();
            ajastin.Start();
        }

        void LuoPilvet()
        {
            isoPilvi = new GameObject(400, 150);
            isoPilvi.Image = pilvenAlphaKuva;
            Add(isoPilvi, 1);

            pieniPilvi = new GameObject(200, 75);
            pieniPilvi.Image = pilvenKuvaPeilattu;
            Add(pieniPilvi, -1);

            miniPilvi = new GameObject(50, 30);
            miniPilvi.Image = pilvenKuva;
            Add(miniPilvi, -1);
        }

        void LuoAikaLaskuri()
        {

            aikamittari = new DoubleMeter(0);

            aikalaskuri = new Timer();
            aikalaskuri.Interval = 0.1;
            aikalaskuri.Timeout += KasvataAikaa;
            aikalaskuri.Start();
            
            aikanaytto = new Label(70, 30);
            aikanaytto.DecimalPlaces = 1;
            aikanaytto.TextColor = new Color(170, 237, 255);
            aikanaytto.BorderColor = Color.Black;
            aikanaytto.Color = new Color(255, 0, 0, 150);
            aikanaytto.Font = Font.DefaultBold;
            aikanaytto.XMargin = 2;
            aikanaytto.X = Screen.Left + 38;
            aikanaytto.Y = Screen.Top - 17;
            aikanaytto.BindTo(aikamittari);
            Add(aikanaytto);
        }

        void LuoReunat()
        {
            PhysicsObject alareuna = PhysicsObject.CreateStaticObject(Level.Width, 40);
            alareuna.Image = alaReunaKuva;
            alareuna.Position = new Vector(0, Level.Bottom + 20);
            alareuna.Restitution = 1;
            Add(alareuna, 2);

            PhysicsObject ylareuna = PhysicsObject.CreateStaticObject(Level.Width, 40);
            ylareuna.Image = ylaReunaKuva;
            ylareuna.Position = new Vector(0, Level.Top - 20);
            ylareuna.Restitution = 1;
            Add(ylareuna, 2);

            PhysicsObject vasenreuna = PhysicsObject.CreateStaticObject(46, Level.Height);
            vasenreuna.Image = vasenReunaKuva;
            vasenreuna.Position = new Vector(Level.Left + 23, 0);
            vasenreuna.Restitution = 1;
            Add(vasenreuna, 2);

            PhysicsObject oikeareuna = PhysicsObject.CreateStaticObject(58, Level.Height);
            oikeareuna.Image = oikeaReunaKuva;
            oikeareuna.Position = new Vector(Level.Right - 29, 0);
            oikeareuna.Restitution = 1;
            Add(oikeareuna, 2);
        }

        protected override void Update(Time time)
        {
            if (pelihahmo != null)
            {
                isoPilvi.X = -0.25 * (pelihahmo.X - 500);
                isoPilvi.Y = -0.15 * (pelihahmo.Y + 800);

                pieniPilvi.X = -0.05 * (pelihahmo.X + 2400);
                pieniPilvi.Y = -0.05 * (pelihahmo.Y - 1000);

                miniPilvi.X = -0.02 * (pelihahmo.X - 8000);
                miniPilvi.Y = -0.02 * (pelihahmo.Y - 5000);

                if (pelihahmo.Velocity.X > 0)
                {
                    pelihahmo.Animation = ilmapallonAnimaatioOikealle;
                    //pelihahmo.Animation = new Animation(Image.Mirror(ilmapallonKuvat));
                    pelihahmo.Animation.FPS = 8;
                }
                else if (pelihahmo.Velocity.X < 0)
                {
                    pelihahmo.Animation = ilmapallonAnimaatioVasemmalle;

                    //pelihahmo.Animation = new Animation(ilmapallonKuvat);
                    pelihahmo.Animation.FPS = 8;
                }
            }

            base.Update(time);
        }

        void KasvataAikaa()
        {
            aikamittari.Value += aikalaskuri.Interval;
        }

        void Ajastinapu()
        {
            ajastin.Interval += 1;
            impulssinVoima += 50;
            viholliset.Add( LuoPiikkiPallo() );
        }

        void LuoPeliHahmo()
        {
            pelihahmo = new PhysicsObject(25.0, 25.0);
            pelihahmo.Shape = Shape.Rectangle;
            pelihahmo.Animation = ilmapallonAnimaatioOikealle;
            pelihahmo.CanRotate = false;

            AddCollisionHandler(pelihahmo, KasitteleOsumama);
        }

        PhysicsObject LuoPiikkiPallo()
        {
            PhysicsObject pallo = new PhysicsObject(50.0, 50.0);
            pallo.Shape = Shape.Circle;
            pallo.Tag = "pallo";

            pallo.X = RandomGen.NextDouble(Level.Left + 50, Level.Right - 50);
            pallo.Y = RandomGen.NextDouble(Level.Bottom + 50, Level.Top - 50);

            if ((pallo.Position - pelihahmo.Position).Magnitude < 100)
            {
                if (pelihahmo.X < 0) pallo.X += 100;
                else pallo.X -= 100;

                if (pelihahmo.Y < 0) pallo.Y += 100;
                else pallo.Y -= 100;
            }

            pallo.MomentOfInertia = 1500;
            pallo.Restitution = 1.1;
            //pallo.
            pallo.Image = pikkiPallonKuva;
            Add(pallo);

            Vector impulssi = Vector.FromLengthAndAngle(impulssinVoima, (pallo.Position - pelihahmo.Position).Angle + RandomGen.NextAngle(-Angle.FromRadians(Math.PI / 4), Angle.FromRadians(Math.PI / 4)));
            pallo.Hit(impulssi);

            return pallo;
        }

        void AsetaOhjaimet()
        {
            TouchPanel.Listen(ButtonState.Down, LiikutaKosketuksella, null);
            PhoneBackButton.Listen(AsetaPause, null);
        }

        void AsetaPause()
        {
            ClearControls();
            peliPausella = true;
            this.PhysicsEnabled = false;

            ajastin.Pause();
            aikalaskuri.Pause();

            Label pauseLabel = new Label("Paused");
            pauseLabel.Size = new Vector(400, 200);
            pauseLabel.SizeMode = TextSizeMode.StretchText;
            pauseLabel.Font = Font.DefaultLargeBold;
            pauseLabel.TextColor = new Color(170, 237, 255);
            pauseLabel.BorderColor = Color.Black;
            pauseLabel.Color = new Color(255, 0, 0, 150);
            Add(pauseLabel);

            PushButton exitButton = new PushButton(400, 50);
            exitButton.Text = "Quit game";
            exitButton.Font = Font.DefaultBold;
            exitButton.Y = -150;
            Add(exitButton);

            TouchPanel.ListenOn(exitButton, ButtonState.Pressed, delegate { Exit(); }, null);

            TouchPanel.Listen(ButtonState.Pressed, delegate
            {
                pauseLabel.Destroy();
                exitButton.Destroy();

                if (pelihahmo.IsAddedToGame == false)
                {
                    peliPausella = false;
                    this.PhysicsEnabled = true;

                    Alku();
                }
                else
                {
                    ClearControls();
                    peliPausella = false;
                    this.PhysicsEnabled = true;

                    AsetaOhjaimet();

                    ajastin.Start();
                    aikalaskuri.Start();
                }

            }, null);

            PhoneBackButton.Listen(delegate
            {
                pauseLabel.Destroy();
                exitButton.Destroy();

                if (pelihahmo.IsAddedToGame == false)
                {
                    peliPausella = false;
                    this.PhysicsEnabled = true;
                    Alku();
                }
                else
                {
                    ClearControls();
                    peliPausella = false;
                    this.PhysicsEnabled = true;
                    AsetaOhjaimet();

                    ajastin.Start();
                    aikalaskuri.Start();
                }
            }, null);

        }

        void LiikutaKosketuksella(Touch t)
        {
            pelihahmo.Push(t.MovementOnScreen * 100);
        }

        void KasitteleOsumama(PhysicsObject osuja, PhysicsObject osuttu)
        {
            aikalaskuri.Pause();
            ajastin.Stop();
            
            osuja.Destroy();

            //popSound.Play();
            rajahdys.AddEffect(osuja.Position, 100);

            ClearControls();

            Timer.SingleShot(1.5, delegate { topLista.EnterAndShow(Math.Round(aikamittari, 1)); });
        }

        void Lopeta(Window w)
        {
            //ClearAll();
            Alku();
        }
    }
}
