﻿using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Effects;
using Jypeli.Widgets;
using Jypeli.WP7;

public class Sniper : PhysicsGame
{
   
    Flame liekki;
    ExplosionSystem rajahdys;
    ExplosionSystem posaus;

    [Save] public IntMeter pisteLaskuri;
    Label pisteNaytto;

    [Save] public PhysicsObject maalitaulu;
    [Save] public GameObject ammusmittari;
    //[Save] public GameObject pistetausta;
    GameObject pistetausta;
    [Save] public GameObject overlätkä;

    ScoreList topLista = new ScoreList(5, false, 0);

    Image taulunKuva = LoadImage("maalitaulu");
    Image ammusMittari0 = LoadImage("ammukset01");
    Image ammusMittari1 = LoadImage("ammukset11");
    Image savuHiukkanen = LoadImage("savuhiukkanen");
    Image posausHiukkanen = LoadImage("posaushiukkanen");
    Image räjähdysHiukkanen = LoadImage("räjähdyshiukkanen");
    Image radioaktiivinenHiukkanen = LoadImage("radioaktiivinen hiukkanen");
    Image pisteTausta = LoadImage("pistetausta");
    Image youFailed = LoadImage("Game Over_wp7");
    Image esittelyKuva = LoadImage("esittelynaytto");

    SoundEffect latausÄäni = LoadSoundEffect("Pump Shotgun");//Recorded by Mike Koenig

    SoundEffect ampumisÄäni = LoadSoundEffect("Sniper_Rifle");
    SoundEffect räjähdysÄäni = LoadSoundEffect("Bomb");

    [Save] public int pMaxMaara = 2000;
    [Save] public double työntöVoima = -220.0;
    [Save] public bool loppunutPeli;
    [Save] public bool osuttu;
    [Save] public bool jatkettuPeli;
    [Save] public bool peliPausella;

    [Save] public int ammuksia;

    GameObject esittely;
    Smoke alkusavu;

    public override void Begin()
    {
        peliPausella = false;
        AloitaAlusta();
        maalitaulu.Stop();

        pisteNaytto.Destroy();
        
        esittely = new GameObject(Level.Width, Level.Height);
        esittely.Image = esittelyKuva;
        Add(esittely, 3);

        alkusavu = new Smoke(radioaktiivinenHiukkanen, 30);
        alkusavu.X = 350;
        alkusavu.Y = -140;
        Add(alkusavu, 3);

        Wind = new Vector(-20, 2);
        
        ClearControls();
        TouchPanel.Listen(ButtonState.Pressed, PoistuttuAlkuvalikosta, null);

        PhoneBackButton.Listen(Exit, null);
    }

    void PoistuttuAlkuvalikosta(Touch t)
    {
        AsetaOhjaimet();
        esittely.Destroy();
        alkusavu.Destroy();
        pistetausta.Destroy();
        LuoPisteMittari();
        //Remove(pisteNaytto);
        TyönnäTaulua(työntöVoima);
    }

    public override void Continue()
    {
        AloitaAlusta();
        Timer.SingleShot(0.1, PalattuPeliin);
    }

    void PalattuPeliin()
    {
        maalitaulu.Stop();
        peliPausella = false;

        if (ammuksia == 1) ammusmittari.Image = ammusMittari1;
        else if (ammuksia < 1) ammusmittari.Image = ammusMittari0;
        
        if (loppunutPeli == true)
        {
            ClearControls();
            TouchPanel.Listen(ButtonState.Pressed, delegate
            {
                loppunutPeli = false;
                AloitaAlusta();
            },
            null);

            PhoneBackButton.Listen(delegate
            {
                loppunutPeli = false;
                AloitaAlusta();
            },
            null);
        }
        else
        {
            ClearControls();
            Label jatkaLabel = new Label("Press to continue");
            jatkaLabel.Font = Font.DefaultLarge;
            jatkaLabel.TextColor = Color.Red;
            Add(jatkaLabel);

            if (osuttu == true)
            {
                maalitaulu.Destroy();
                LuoMaalitaulu(RandomGen.NextDouble(Level.Left + 50, Level.Right - 50), Level.Top + 200);
                maalitaulu.Stop();
            }

            TouchPanel.Listen(ButtonState.Pressed, delegate
            {
                ClearControls();
                AsetaOhjaimet();
                jatkaLabel.Destroy();
                if (ammuksia == -1)
                {
                    ammusmittari.Image = ammusMittari0;
                    Timer.SingleShot(1.2, LataaAse2);
                }
                TyönnäTaulua(työntöVoima);
            },
            null);

            PhoneBackButton.Listen(delegate
            {
                ClearControls();
                AsetaOhjaimet();
                jatkaLabel.Destroy();
                if (ammuksia == -1)
                {
                    ammusmittari.Image = ammusMittari0;
                    Timer.SingleShot(1.2, LataaAse2);
                }
                TyönnäTaulua(työntöVoima);
            },
            null);
        }
    }

    void LuoAmmusMittari()
    {
        ammusmittari = new GameObject(150, 150);
        ammusmittari.X = Level.Right - 75;
        ammusmittari.Y = Level.Bottom + 75;
        Add(ammusmittari, 1);

        if (ammuksia == 1) ammusmittari.Image = ammusMittari1;
        else if (ammuksia == 0) ammusmittari.Image = ammusMittari0;
    }

    void LuoPisteMittari()
    {
        pistetausta = new GameObject(200, 130);
        pistetausta.Image = pisteTausta;
        pistetausta.X = Level.Left + 100;
        pistetausta.Y = Level.Top - 65;
        Add(pistetausta, 1);

        pisteNaytto = new Label();
        pisteNaytto.Position = Camera.WorldToScreen(new Vector(pistetausta.X, pistetausta.Y - 20));
        pisteNaytto.Font = Font.DefaultLargeBold;
        pisteNaytto.TextColor = Color.Red;
        Add(pisteNaytto);
        
        pisteLaskuri = new IntMeter(0);
        pisteNaytto.BindTo(pisteLaskuri);
    }

    void LuoKenttä()
    {
        Level.Width = 800;
        Level.Height = 480;

        Camera.ZoomToLevel();
        Level.Background.CreateStars(1000);

        liekki = new Flame(savuHiukkanen);

        rajahdys = new ExplosionSystem(räjähdysHiukkanen, pMaxMaara);
        rajahdys.MinLifetime = 0.5;
        rajahdys.MaxLifetime = 1.3;
        rajahdys.MinVelocity = 0;
        rajahdys.MaxVelocity = 250;
        rajahdys.MinScale = 0.1;
        rajahdys.MaxScale = 40.5;
        rajahdys.MinRotationSpeed = 0.2;
        rajahdys.MaxRotationSpeed = 2.0;
        rajahdys.IgnoreWind = true;
        Add(rajahdys);

        posaus = new ExplosionSystem(posausHiukkanen, pMaxMaara);
        posaus.MinLifetime = 0.1;
        posaus.MaxLifetime = 0.5;
        posaus.MinVelocity = 0;
        posaus.MaxVelocity = 500;
        posaus.MinScale = 0.1;
        posaus.MaxScale = 40.0;
        posaus.MinRotationSpeed = 0.2;
        posaus.MaxRotationSpeed = 2.0;
        Add(posaus);
    }

    void AsetaOhjaimet()
    {
        ClearControls();
        TouchPanel.Listen(ButtonState.Pressed, AmmuHuti, null);
        TouchPanel.ListenOn(ammusmittari, ButtonState.Pressed, LataaAse, null);
        PhoneBackButton.Listen(PauseMenu, null);
    }

    void PauseMenu()
    {
        if (peliPausella) return;
        maalitaulu.Stop();
        peliPausella = true;

        Label pauseLabel = new Label("Paused");
        pauseLabel.Size = new Vector(400, 200);
        pauseLabel.SizeMode = TextSizeMode.StretchText;
        pauseLabel.Font = Font.DefaultLargeBold;
        pauseLabel.TextColor = new Color(170, 237, 255);
        pauseLabel.BorderColor = Color.Black;
        pauseLabel.Color = new Color(255, 0, 0, 150);
        Add(pauseLabel);

        PushButton exitButton = new PushButton(400, 50);
        exitButton.Text = "Quit game";
        exitButton.Font = Font.DefaultBold;
        exitButton.Y = -150;
        Add(exitButton);

        ClearControls();

        TouchPanel.ListenOn(exitButton, ButtonState.Pressed, delegate { Exit(); }, null);

        TouchPanel.Listen(ButtonState.Pressed, delegate
        {
            ClearControls();
            pauseLabel.Destroy();
            exitButton.Destroy();

            AsetaOhjaimet();
            peliPausella = false;
            TyönnäTaulua(työntöVoima);
        }, null);

        PhoneBackButton.Listen(delegate
        {
            ClearControls();
            pauseLabel.Destroy();
            exitButton.Destroy();

            AsetaOhjaimet();
            peliPausella = false;
            TyönnäTaulua(työntöVoima);
        }, null);

    }

    void AmmuHuti(Touch kosketus)
    {
        Vector d = maalitaulu.Position - kosketus.PositionOnWorld;

        if (ammuksia > 0 && d.Magnitude < maalitaulu.Width / 2)
        {
            Phone.Vibrate(50);
            ammuksia = ammuksia - 1;
            Ammu();
        }
        else if (ammuksia > 0)
        {
            ampumisÄäni.Play();
            ammuksia = 0;
            ammusmittari.Image = ammusMittari0;
        }
        else if (ammuksia == 0)
        {
            //play a sound??
            //MessageDisplay.Add(" Your weapon is not loaded. Press bottom right corner to reload weapon.");
        }
    }

    void LataaAse(Touch kosketus)
    {
        if (ammuksia == 0)
        {
            Phone.Vibrate(50);
            ammuksia = -1;
            Timer.SingleShot(1.4, LataaAse2);
            latausÄäni.Play();
        }
        else
        {
            AmmuHuti(kosketus);
            //MessageDisplay.Add("You are already loaded your weapon.");
        }
    }

    void LataaAse2()
    {
        ammuksia = 1;
        ammusmittari.Image = ammusMittari1;
    }

    void Ammu()
    {
        Add(liekki);

        RajaytaTaulu1();

        Timer.SingleShot(0.6, RajaytaTaulu);
        ampumisÄäni.Play();
        pisteLaskuri.Value++;
        osuttu = true;

        if (ammuksia == 0)
        {
            ammusmittari.Image = ammusMittari0;
        }
    }

    void RajaytaTaulu()
    {
        double x = maalitaulu.X;
        double y = maalitaulu.Y;

        rajahdys.AddEffect(x, y, 200);
        
        räjähdysÄäni.Play();
        maalitaulu.Destroy();
        
        Timer.SingleShot(0.7, SammutaLiekki);
    }

    void RajaytaTaulu1()
    {
        double x = maalitaulu.X;
        double y = maalitaulu.Y - 50;
        posaus.AddEffect(x, y, 200);
    }

    void SammutaLiekki()
    {
        liekki.Destroy();
        liekki = new Flame(savuHiukkanen);
        liekki.IgnoreWind = true;

        työntöVoima = työntöVoima - 35;
        LuoMaalitaulu(RandomGen.NextDouble(Level.Left + 50, Level.Right - 50), Level.Top + 200);
    }

    void LuoMaalitaulu( double x, double y )
    {
        
        maalitaulu = new PhysicsObject( 100.0, 100.0);
        maalitaulu.Image = taulunKuva;
        maalitaulu.X = x;
        maalitaulu.Y = y;
        osuttu = false;
        Add(maalitaulu);

        if (!peliPausella) TyönnäTaulua(työntöVoima);
    }

    void GameOver()
    {
        //if (loppunutPeli == true)
        //{
            if (maalitaulu == null || maalitaulu.IsDestroyed == true) return;
                    
            if (maalitaulu.Y < Level.Bottom - 200 && osuttu == false)
            {
                maalitaulu.Destroy();
                loppunutPeli = true;
                
                ClearControls();
                TouchPanel.Listen(ButtonState.Pressed, delegate {
                    loppunutPeli = false;
                    AloitaAlusta(); 
                }, null);

                PhoneBackButton.Listen(delegate
                {
                    loppunutPeli = false;
                    AloitaAlusta();
                }, null);
                
                overlätkä = new GameObject(300, 200);
                overlätkä.Image = youFailed;
                Add(overlätkä, 2);

                ammusmittari.Destroy();
                MessageDisplay.Clear();

                HighScoreWindow topIkkuna = new HighScoreWindow("Sniper", "Congratulations! You shot %p targets! \n Enter your name:",
                            topLista, pisteLaskuri.Value);
                topIkkuna.Closed += TallennaPisteet;
                Add(topIkkuna);
            }
        //}
    }

    void TallennaPisteet(Window sender)
    {
        DataStorage.Save<ScoreList>(topLista, "pisteet.xml");
    }

    void TyönnäTaulua(double työnnä)
    {
        if(maalitaulu != null)
            maalitaulu.Hit(new Vector(0, työnnä));
    }

    void AloitaAlusta()
    {
        ClearAll();

        Phone.DisplayOrientation = Jypeli.WP7.DisplayOrientation.LandscapeLeft;
        Phone.DisplayResolution = DisplayResolution.Large;
        IsFullScreen = true;

        if (DataStorage.Exists("pisteet.xml"))
            topLista = DataStorage.Load<ScoreList>(topLista, "pisteet.xml");


        overlätkä = new GameObject(300, 200);
        overlätkä.Image = youFailed;
        
        LuoKenttä();
        LuoAmmusMittari();
        LuoPisteMittari();
        AsetaOhjaimet();

        loppunutPeli = false;

        työntöVoima = -220.0;
        LuoMaalitaulu(RandomGen.NextDouble(Level.Left + 50, Level.Right - 50), Level.Top + 200);
        //TyönnäTaulua(työntöVoima);

        MessageDisplay.MaxMessageCount = 2;
        MessageDisplay.TextColor = Color.Red;

        if (!jatkettuPeli)
        {
            LataaAse2();
        }
    }


    protected override void Update(Time time)
    {
        
        if (liekki != null)
        {
            liekki.Position = maalitaulu.Position;
        }

        if (loppunutPeli != true)
        {
            GameOver();
        }

        base.Update(time);
    }
}

