﻿using System;
using System.Collections.Generic;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Effects;
using Jypeli.Widgets;
using Jypeli.WP7;

public class Peli : PhysicsGame
{
    [Save] public PhysicsObject UFO;
    Image olionKuva = LoadImage("ufo");
    Image taustaKuva = LoadImage("m101");
    Image ValikonKuva = LoadImage("valikko2");
    [Save] public int nopeutus = 0;
    public Timer aikaLaskuri;
    //[Save] public double aikaLaskuriArvo;
    [Save] public DoubleMeter alaspainLaskuri;
    [Save] public bool jatkettuPeli;
    [Save] public bool valikossa = true;
    List<Label> valikonKohdat;
    public Timer ajastin;

    //Jypeli.Widgets.EasyHighScore

    EasyHighScore easyTopLista = new EasyHighScore("spaceracetopten.xml", 10, "");
    ExplosionSystem rajahdys = new ExplosionSystem(LoadImage("123"), 200);


    public override void Begin()
    {
        
        rajahdys.Color = Color.Transparent;

        // Nämä ovat tässä jotta Continue toimii suoraan alkuvalikossa
        UFO = new PhysicsObject(30, 30);
        alaspainLaskuri = new DoubleMeter(0);

        Phone.DisplayResolution = DisplayResolution.Large;
        Level.Width = 1200;//800;
        Level.Height = 720;// 480;
        IsFullScreen = true;
        Add(rajahdys);
        jatkettuPeli = false;
        valikossa = true;
        tallennaTila();
        Valikko();
        //ValikossaLiikkuminen();
        //AsetaOhjaimet();
        //LuoAikaLaskuri();
    }

    public override void Continue()
    {
        //jatkettuPeli = false;
        LoadState tilanteenLataus = DataStorage.BeginLoad("pelitilanne.xml");
        jatkettuPeli = tilanteenLataus.Load<bool>(jatkettuPeli, "jatkettu");
        valikossa = tilanteenLataus.Load<bool>(valikossa, "valikossa");
        tilanteenLataus.EndLoad();

        if (valikossa)
            Valikko();
        else
            AloitaPeli();
    }

    void tallennaTila()
    {
        SaveState tilanneTallennus = DataStorage.BeginSave("pelitilanne.xml");
        tilanneTallennus.Save<bool>(jatkettuPeli, "jatkettu");
        tilanneTallennus.Save<bool>(valikossa, "valikossa");
        tilanneTallennus.EndSave();
    }

    void JatkaPelia(Touch kosketus)
    {
        jatkettuPeli = true;
        tallennaTila();
        AloitaPeli();
    }

    void JatkaPelia()
    {
        jatkettuPeli = true;
        tallennaTila();
        AloitaPeli();
    }

    void LuoSatunnainenEste()
    {
        double y = RandomGen.NextDouble(Level.Bottom, Level.Top);
        PhysicsObject Este = PhysicsObject.CreateStaticObject(35.0, 300.0);
        Add(Este);
        Este.Tag = "este";
        Este.X = Level.Right + RandomGen.NextDouble(0, 400);
        Este.Y = y;
        Este.Color = Color.Black;
        Este.Velocity = new Vector(-250 - (RandomGen.NextDouble(nopeutus / 2, nopeutus)), 0.0);

        nopeutus += 7;
    }

    void AsetaOhjaimet()
    {
        TouchPanel.Listen(ButtonState.Down, LiikutaUFO, "Liikuttaa UFOa");
        PhoneBackButton.Listen(PalaaValikkoon, "Mene valikkoon");
        Keyboard.Listen(Key.Escape, ButtonState.Released, Exit, null);
        Keyboard.Listen(Key.Up, ButtonState.Down,
          LiikutaUFO, null, new Vector(0, 1000));
        Keyboard.Listen(Key.Down, ButtonState.Down,
          LiikutaUFO, null, new Vector(0, -1000));
        Keyboard.Listen(Key.Right, ButtonState.Down,
          LiikutaUFO, null, new Vector(1000, 0)); 
        Keyboard.Listen(Key.Left, ButtonState.Down,
          LiikutaUFO, null, new Vector(-1000, 0));
        Keyboard.Listen(Key.LeftControl, ButtonState.Down,
          delegate { UFO.Stop(); }, null);
        Keyboard.Listen(Key.RightControl, ButtonState.Down,
          delegate { UFO.Stop(); }, null);

    }

    void LiikutaUFO(Touch kosketus)
    {
        UFO.Push((kosketus.PositionOnWorld - UFO.Position).Normalize() * 1000);
        /*if (kosketus.PositionOnScreen.Y < UFO.Position.Y)
            UFO.Push(new Vector(0, -1000));
        if (kosketus.PositionOnScreen.Y > UFO.Position.Y)
            UFO.Push(new Vector(0, 1000));
        if (kosketus.PositionOnScreen.X > UFO.Position.X)
            UFO.Push(new Vector(1000, 0));
        if (kosketus.PositionOnScreen.X < UFO.Position.X)
            UFO.Push(new Vector(-1000, 0));*/
    }

    void LiikutaUFO(Vector vektori)
    {
        UFO.Push(vektori);

    }
    void LuoRajahdys()
    {
        rajahdys.AddEffect(UFO.X, UFO.Y, 200);
        aikaLaskuri.Stop();
        ajastin.Stop();
    }

    void KasitteleUfonTormays(PhysicsObject UFO, PhysicsObject kohde)
    {
        Phone.Vibrate(500);
        LuoRajahdys();
        UFO.Destroy();
        EsitaPistelista();
    }

    void LuoAikaLaskuri(bool jatkettu)
    {
        if (!jatkettu)
            alaspainLaskuri = new DoubleMeter(0);

        aikaLaskuri = new Timer();
        aikaLaskuri.Interval = 0.1;
        aikaLaskuri.Timeout += LaskeAlaspain;
        aikaLaskuri.Start();

        Label aikaNaytto = new Label();
        aikaNaytto.TextColor = Color.White;
        aikaNaytto.DecimalPlaces = 1;
        aikaNaytto.BindTo(alaspainLaskuri);
        Add(aikaNaytto);
        aikaNaytto.X = Screen.RightSafe - 40;
        aikaNaytto.Y = Screen.TopSafe - 20;
    }

    void LaskeAlaspain()
    {
        alaspainLaskuri.Value += 2;
        //aikaLaskuriArvo = alaspainLaskuri.Value;

    }

    void PalaaValikkoon()
    {
        SaveGame("spacerace.xml");
        ajastin.Stop();
        aikaLaskuri.Stop();
        jatkettuPeli = true;
        valikossa = true;
        tallennaTila();
        Valikko();
    }

    void AloitaUusiPeli(Touch kosketus)
    {
        jatkettuPeli = false;
        valikossa = false;
        tallennaTila();
        AloitaPeli();
    }

    void AloitaUusiPeli()
    {
        jatkettuPeli = false;
        valikossa = false;
        tallennaTila();
        AloitaPeli();
    }

    void AloitaPeli()
    {
        ClearAll();

        Phone.DisplayResolution = DisplayResolution.Large;
        Level.Width = 1200;//800;
        Level.Height = 720;// 480;
        nopeutus = 0;
        rajahdys = new ExplosionSystem(LoadImage("123"), 200);
        Add(rajahdys);
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, PalaaValikkoon, "Palaa valikkoon");
        AsetaOhjaimet();
        LuoAikaLaskuri(jatkettuPeli);

        UFO = new PhysicsObject(30.0, 30.0);
        Add(UFO);
        UFO.Image = olionKuva;

        if (jatkettuPeli)
            LoadGame("spacerace.xml");
        else
        {
            UFO.X = Level.Left + 250;
            UFO.Y = 0.0;
        }
        UFO.IgnoresCollisionResponse = true;

        Vector impulssi = new Vector(300.0, 0.0);
        UFO.Restitution = 1.0;
        Level.BackgroundColor = Color.White;
        Camera.ZoomToLevel();
        Level.Background.Image = taustaKuva;
        Level.CreateBorders(false);

        ajastin = new Timer();
        ajastin.Interval = 1.5;
        ajastin.Timeout += LuoSatunnainenEste;
        ajastin.Start();
        AddCollisionHandler(UFO, KasitteleUfonTormays);
    }

    void Valikko(Touch kosketus)
    {
        Valikko();
    }

    void Valikko()
    {
        ClearAll();

        // Nämä ovat tässä jotta Continue toimii suoraan alkuvalikossa
        UFO = new PhysicsObject(30, 30);
        alaspainLaskuri = new DoubleMeter(0);
        Phone.DisplayResolution = DisplayResolution.Large;
        IsFullScreen = true;

        Camera.ZoomFactor = 1;
        Level.Background.Image = ValikonKuva;
        Level.Background.Size = new Vector(Screen.Width, Screen.Height);
        
        valikonKohdat = new List<Label>();

        //Label kohtaJatkettu = new Label("Jatka peliä");
        Label kohtaJatkettu = new Label("Continue game");
        kohtaJatkettu.Font = Font.DefaultLarge;
        kohtaJatkettu.TextColor = Color.White;
        kohtaJatkettu.Position = new Vector(0, 120);
        if (jatkettuPeli)
            valikonKohdat.Add(kohtaJatkettu);

        //Label kohta1 = new Label("Aloita uusi peli"); 
        Label kohta1 = new Label("New game");
        kohta1.Font = Font.DefaultLarge;
        kohta1.TextColor = Color.White;
        kohta1.Position = new Vector(0, 60);
        valikonKohdat.Add(kohta1);

        //Label kohta2 = new Label("Lopeta");
        Label kohta2 = new Label("Exit");
        kohta2.Font = Font.DefaultLarge;
        kohta2.TextColor = Color.White;
        kohta2.Position = new Vector(0, -60);
        valikonKohdat.Add(kohta2);

        //Label kohta3 = new Label("Pistelista");
        Label kohta3 = new Label("Highscores");
        kohta3.Font = Font.DefaultLarge;
        kohta3.TextColor = Color.White;
        kohta3.Position = new Vector(0, 0);
        valikonKohdat.Add(kohta3);

        foreach (Label valikonKohta in valikonKohdat)
        {
            Add(valikonKohta);
        }
        if (jatkettuPeli)
        {
            TouchPanel.ListenOn(kohtaJatkettu, ButtonState.Pressed, JatkaPelia, null);
            Mouse.ListenOn(kohtaJatkettu, MouseButton.Left, ButtonState.Pressed, JatkaPelia, null);
        }

        TouchPanel.ListenOn(kohta1, ButtonState.Pressed, AloitaUusiPeli, null);
        TouchPanel.ListenOn(kohta2, ButtonState.Pressed, delegate { Exit(); }, null);
        TouchPanel.ListenOn(kohta3, ButtonState.Pressed, Pistelista, null);

        Mouse.ListenOn(kohta1, MouseButton.Left, ButtonState.Pressed, AloitaUusiPeli, null);
        Mouse.ListenOn(kohta2, MouseButton.Left, ButtonState.Pressed, Exit, null);
        Mouse.ListenOn(kohta3, MouseButton.Left, ButtonState.Pressed, Pistelista, null);

        Keyboard.Listen(Key.Escape, ButtonState.Pressed, Exit, "");
        if (jatkettuPeli)
            PhoneBackButton.Listen(JatkaPelia, "");
        else
            PhoneBackButton.Listen(Exit, "");

        Mouse.IsCursorVisible = true;
        Mouse.ListenMovement(1.0, ValikossaLiikkuminen, null);
    }

    void Pistelista(Touch kosketus)
    {
        Pistelista();
    }

    void Pistelista()
    {
        //easyTopLista.Text = "Parhaat pisteet";
        easyTopLista.Text = "Highscores";
        easyTopLista.Show();
        /*HighScoreWindow topIkkuna = new HighScoreWindow("Space Race",
                              "Parhaat pisteet",
                              topLista);
        topIkkuna.Closed += TallennaPisteet;

        
        topIkkuna.Height = 200;
        topIkkuna.Width = 300;

        Add(topIkkuna);
        
        topIkkuna.ActiveColor = Color.White;
        topIkkuna.CloseButton.Color = Color.White;
        topIkkuna.OKButton.Color = Color.White;
        topIkkuna.TitleBarActiveColor = Color.Blue;*/
    }


    void ValikossaLiikkuminen(AnalogState hiirenTila)
    {
        foreach (Label kohta in valikonKohdat)
        {
            if (Mouse.IsCursorOn(kohta))
            {
                kohta.TextColor = Color.Black;
            }
            else
            {
                kohta.TextColor = Color.White;
            }

        }
    }


    void EsitaPistelista()
    {
        //easyTopLista.Text = "Parhaat pisteet";
        easyTopLista.Text = "Highscore";
        //easyTopLista.EnterText = string.Format("Tumpelo etkö nyt parempaan pystynyt? {0}! No, Syötä nyt nimesi:", alaspainLaskuri.Value);
        easyTopLista.EnterText = string.Format("Can't you do any better? {0}! Well, insert your name:", alaspainLaskuri.Value);
        easyTopLista.EnterAndShow(alaspainLaskuri.Value);
        //Valikko();
        TouchPanel.Listen(ButtonState.Pressed, AloitaUusiPeli, null);
        /*HighScoreWindow topIkkuna = new HighScoreWindow("Space Race",
                         "Parhaat pisteet",
                         "Tumpelo etkö nyt parempaan pystynyt? %p! No, Syötä nyt nimesi:",
                         topLista, alaspainLaskuri.Value);
        topIkkuna.Closed += TallennaPisteet;
        Add(topIkkuna);*/
    }

}

